<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Attendence extends My_Controller {

	public function __construct(){
		parent::__construct();
	}

	public function day_wise(){
		$this->load->template('attendence/day_wise', $this->data);
	}


	public function monthly_summary(){
		$this->load->template('attendence/monthly_summary', $this->data);
	}


	public function upload_attendence(){
		$this->load->template('attendence/upload_attendence', $this->data);
	}


	public function excel_upload_format(){
		
		$this->load->library('XLSXWriter', NULL, 'xlsx_writer');

		$file_name = "attendence-upload-format.xlsx";
		header('Content-disposition: attachment; filename="'.$this->xlsx_writer->sanitize_filename($file_name).'"');
    	header("Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
    	header('Content-Transfer-Encoding: binary');
    	header('Cache-Control: must-revalidate');
    	header('Pragma: public');

    	$this->xlsx_writer->setAuthor("AncileTech");

    	$sheet_name = "Attendence";

		$header = ["string", "string", "string", "string", "string"];

        $col_options = [
        	              "widths"       => [5,40,15,15,15], 
        	              "freeze_rows"  => TRUE,
        	              "suppress_row" => TRUE
        	           ];


        $this->xlsx_writer->writeSheetHeader($sheet_name, $header, $col_options);	


        $header_row_labels = ["#","Employee ID", "Date", "In Time", "Out Time"];   

        $header_row_options = [
		        	              "font"       => "Calibri", 
		        	              "font-size"  => 10,
		        	              "font-style" => "bold",
		        	              "fill"       => "#fff",
		        	              "halign"     => "center",
		        	              "border"     => "left,right,top,bottom"
		        	           ];


        $this->xlsx_writer->writeSheetRow($sheet_name, $header_row_labels, $header_row_options); 	


        $this->load->model('user_model');

	    $this->data['users'] = $this->user_model->user_list(['user_role_id' => 2]);
       
        //2nd sheet employee list start
	    $sheet_name2 = "Employees";  

	    $this->load->model('user_model');

	    $users = $this->user_model->user_list(['user_role_id' => 2]);

	    $header = ["string", "string", "string"];

        $col_options = [
        	              "widths"       => [5,40,20], 
        	              "freeze_rows"  => TRUE,
        	              "suppress_row" => TRUE
        	           ];

        $this->xlsx_writer->writeSheetHeader($sheet_name2, $header, $col_options); 


        $header_row_labels = ["#","Employee Name", "Employee ID"];   

        $header_row_options = [
		        	              "font"       => "Calibri", 
		        	              "font-size"  => 10,
		        	              "font-style" => "bold",
		        	              "fill"       => "#fff",
		        	              "halign"     => "center",
		        	              "border"     => "left,right,top,bottom"
		        	           ];
        
        $this->xlsx_writer->writeSheetRow($sheet_name2, $header_row_labels, $header_row_options);

        if ($users) {
        	foreach ($users as $i => $user) {

        		$row_labels = [($i+1),$user->user_first_name." ".$user->user_last_name, $user->user_emp_code]; 

        		$row_options = [
	        	              "font"       => "Calibri", 
	        	              "font-size"  => 8,
	        	              "fill"       => "#d9edf7",
	        	              "halign"     => "center",
	        	              "border"     => "left,right,top,bottom"
	        	           ];

            	$this->xlsx_writer->writeSheetRow($sheet_name2, $row_labels, $row_options);  
        	}
        }
        //2nd sheet employee list end


        $this->xlsx_writer->writeToStdOut();
    
        exit(0);           
	}



}