<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Cron extends My_Controller {

	private $br;

	public function __construct(){
		parent::__construct();

		if (!$this->input->is_cli_request()) {

			$this->br = "<br>";
			//return redirect('https://anciletech.com/welcome/home.act');
		}
		else{
			$this->br = PHP_EOL;
		}
	}


	public function assign_yearly_leaves(){
		
	}


	public function check_announcement(){

		$this->load->model('announcement_model');

		$announcement = $this->announcement_model->get_todays_unpublished_announcement();

		if ($announcement) {

			$where_user = NULL;
			
			if ($announcement->announcement_members=='clients') {

				$where_user = "user_role_id=10";
			}
			elseif ($announcement->announcement_members=='team_members') {

				$where_user = "user_role_id!=10";
			}


			$this->db->select('_user_id');

			$this->db->from('users');

			if ($where_user) {
				$this->db->where($where_user, NULL, FALSE);
			}

			$users = $this->db->get()->result_array();
			
			$users = $users ? array_column($users, '_user_id') : array();

			if ($users) {
				
				$notifications = [];

				$notification_row = 
	            [
				   "notification_title"      => $announcement->announcement_title,
				   "notification_from_user_id" => $announcement->announcement_created_by,
				   "notification_action_type"  => "modal",
				   "notification_modal_id"    => "announcements/view-announcement",
				   "notification_modal_data"  => "_announcement_id=".$announcement->_announcement_id 
	            ];

				foreach ($users as $user_id) {
					$notification_row['notification_to_user_id'] = $user_id;

					array_push($notifications, $notification_row);
				}

				$this->load->model('notification_model');

				$this->notification_model->add_bulk_notifications($notifications);

				$this->announcement_model->update_announcement($announcement->_announcement_id, ['announcement_is_published' => 1]);

				echo "Notification has been sent to ".count($users)." users successfully.";
			}
			else{
				echo "No user found to send notification";
			}
			
		}
		else{
			echo "No unpublished notification found for today";
		}
	}



	
}