<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Salary extends My_Controller {

	public function __construct(){
		parent::__construct();
	}



	public function index(){

		$this->load->template('salary/salary-slips', $this->data);
	}


	public function salary_slip($_enc_salary_slip_id=NULL){

		if (!$_enc_salary_slip_id) {
			$this->load->error_404($this->data);
		}
		else{

			$_salary_slip_id = url_decode($_enc_salary_slip_id);

			if (!$_salary_slip_id) {
				$this->load->error_404($this->data);
			}
			else{

				$this->load->model('salary_model');

				$salary_data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
		    	                                     ['_salary_slip_id' => $_salary_slip_id]);

				if (!$salary_data) {
					$this->load->error_404($this->data);
				}
				elseif ($salary_data->salary_slip_is_generated==0) {
					$this->load->error_404($this->data);
				}
				elseif (!in_array($this->session->userdata('user_role_id'), [1,3]) && 
			            $salary_data->_user_id!=$this->session->userdata('_user_id')) {
					
					$this->load->error_404($this->data);
				}
				else{
					$this->data["salary_data"] = $salary_data;

					$this->load->library('currency');

					$this->load->model('user_model');

					$this->data["user_data"] = $this->user_model->user_list(['_user_id' => $salary_data->_user_id]);

					$this->data["bank_data"] = $this->user_model->bank_details($salary_data->_user_id);

					$this->data["attendence_data"] = 
					$this->db->from('attendence_summary')
					         ->where('attendence_summary_fin_year_id', $this->session->userdata('_fin_year_id')) 
					         ->where('attendence_summary_user_id', $salary_data->_user_id)
					         ->where('attendence_summary_salary_slip_id', $salary_data->_salary_slip_id)
					         ->get()
					         ->row();

					//$this->load->view('admin/salary/salary_slip_pdf', $this->data);


					$this->load->library('tcpdf/tcpdf', '' ,'tcpdf');
					$this->tcpdf =new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, array(210,355), true, 'UTF-8', false);
					$this->tcpdf->SetCreator(PDF_CREATOR);
					$this->tcpdf->SetAuthor('AncileTech');
					$this->tcpdf->SetTitle('Salary Slip');
					$this->tcpdf->SetSubject('Salary Slip for Joydeep Dey');
					$this->tcpdf->SetKeywords('Salary Slip for Joydeep Dey');

					$this->tcpdf->setPrintHeader(false);

					$this->tcpdf->setPrintFooter(false); 

					$this->tcpdf->SetCellPadding(1.5);

					$this->tcpdf->setImageScale(1.45);

					$this->tcpdf->SetMargins(10,10,10);

					$this->tcpdf->AddPage();

					$this->tcpdf->SetFontSize(11);



					$html = $this->load->view('admin/salary/salary_slip_pdf', $this->data, TRUE);

					$this->tcpdf->writeHTML($html, true, false, true, false, '');

					$filename = "salary-slip-".strtolower($this->data["user_data"]->user_first_name)."-".
					            strtolower($this->data["user_data"]->user_last_name)."-".
					            strtolower(date('F-Y', strtotime($salary_data->salary_slip_month))).".pdf";

					$this->tcpdf->Output($filename, 'I');
				}
			}
			
		}
	}


	
}