<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Settings extends My_Controller {

	public function __construct(){
		parent::__construct();

		if ($this->session->userdata('user_role_id')!=1) {
			$this->load->error_403($this->data);
		}	
	}

	public function index(){
		$this->general();
	}


	public function general(){

		$settings_keys = [
			               'title_bar_name', 'copyright_text', 'favicon', 'logo_icon', 'logo_transparent',
			               'logo_transparent_big', 'logo_wide', 'logo_wide_transparent'
		                 ]; 

		$settings_datas = $this->settings_model->get_bulk_settings($settings_keys);


		$all_settings = [];

		if ($settings_datas) {
			foreach ($settings_datas as $i => $row) {
				$all_settings[$row->settings_key] = $row->settings_value;
			}
		}

		$this->data['general_settings'] = $all_settings;

		$this->load->template('settings/general', $this->data);
	}


	public function company(){

		$settings_keys = [
			               'company_address', 'company_cin', 'company_email', 'company_gst',
			               'company_name', 'company_pan', 'company_phone', 'company_website'
		                 ]; 

		$settings_datas = $this->settings_model->get_bulk_settings($settings_keys);


		$all_settings = [];

		if ($settings_datas) {
			foreach ($settings_datas as $i => $row) {
				$all_settings[$row->settings_key] = $row->settings_value;
			}
		}

		$this->data['company_settings'] = $all_settings;


		$this->load->template('settings/company', $this->data);
	}



	public function user_role_and_permission(){
		$this->load->template('settings/user_role_and_permission', $this->data);
	}




	public function mail_settings(){


		$settings_keys = [
			               'mailer_enc_type', 'mailer_type', 'mail_bcc', 'mail_content_type',
			               'mail_from_email', 'mail_from_name', 'mail_host', 'mail_password',
			               'mail_port', 'mail_reply_to'
		                 ]; 

		$settings_datas = $this->settings_model->get_bulk_settings($settings_keys);


		$all_settings = [];

		if ($settings_datas) {
			foreach ($settings_datas as $i => $row) {
				$all_settings[$row->settings_key] = $row->settings_value;
			}
		}

		$this->data['mail_settings'] = $all_settings;

		$this->load->template('settings/mail_settings', $this->data);
	}



	public function leave(){

		$settings_keys = [
			               'casual_leave_start_date', 'planned_leave_start_date', 'casual_leave_per_month'
		                 ]; 

		$settings_datas = $this->settings_model->get_bulk_settings($settings_keys);


		$all_settings = [];

		if ($settings_datas) {
			foreach ($settings_datas as $i => $row) {
				$all_settings[$row->settings_key] = $row->settings_value;
			}
		}

		$this->data['leave_settings'] = $all_settings;

		$this->load->template('settings/leave', $this->data);
	}


	


	public function financial_year(){
		$this->load->template('settings/financial_year', $this->data);
	}

}