<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Clients extends My_Controller {

	public function __construct(){
		parent::__construct();

		if (!$this->input->is_ajax_request()) {
			$this->load->error_404($this->data);
		}

		$this->load->library('form_validation_rules/admin_rules');
		$this->load->model('clients_model');
	}

	public function client_list(){
		

		$request_data = $_REQUEST;

		$limit  = isset($request_data['length']) ? $request_data['length'] : 10;
		$offset = isset($request_data['start'])  ? $request_data['start']  : 0;

		// getting total number records without any search
		$data = $this->clients_model->clients([
			                                	'limit'    => $limit, 
			                                	'offset'   => $offset
	                                        ]);

		$total_row_count = $this->clients_model->clients([	'count' =>  1 ]);	
		
		$total_filtered_count = $total_row_count;

		if (isset($request_data['search']['value']) && !empty($request_data['search']['value'])) {

			$data = $this->clients_model->clients([
						             	           	'like'     => $request_data['search']['value'],
						             	           	'limit'    => $limit,
						             	           	'offset'   => $offset
							             	    ]);

			$total_filtered_count = count($this->clients_model
				                               ->clients([
                                                            'like'     => $request_data['search']['value'],
                                                            'order_by' => $order_by
                                                        ]));
		}

		$final_data = [];

		if ($data) {
			foreach ($data as $i=> $each_data) {

				$nested_data = [];

				$nested_data[] = ($offset)+($i+1); 

				$nested_data[] = '<a href="'.base_url("clients/details/".$each_data->_client_id).'">'.$each_data->client_name.'</a>';

				$nested_data[] = NULL;

				$nested_data[] = NULL;

				$nested_data[] = NULL;

				$nested_data[] = NULL;

				$nested_data[] ="<ul class=\"nav navbar-nav navbar-right\">
                                    <li class=\"dropdown\">
	                    				<a href=\"javascript:void(0);\" class=\"dropdown-toggle\" 
	                    				   data-toggle=\"dropdown\">
	                    				   <i class=\"fa fa-cog\" ></i><b class=\"caret\"></b>
	                    				</a>
	                    				<ul class=\"dropdown-menu\">
	                      				 	<li>
	                      				    	<a href='javascript:void(0);' class='fa fa-pencil' style='color:#007bff;'
	                      				        	onclick=\"open_modal('clients/edit-client', 
	                      				        	'_client_id=".$each_data->_client_id."');\"> Edit
										    	</a>
										  	</li>
										  	<li>
	                      				    	<a href='javascript:void(0);' class='fa fa-trash' style='color:#dc3545;'
	                      				        	onclick=\"open_modal('clients/delete-client', 
	                      				        	'_client_id=".$each_data->_client_id."');\"> Delete
										     	</a>
										  	</li>
	                    				</ul>
                  					</li>
                  				</ul>";

                $final_data[] =  $nested_data;  				
			}
		}

		$json_data = array(
							"draw"            => intval(isset($request_data['draw']) ? $request_data['draw'] : 1),   
							"recordsTotal"    => intval( $total_row_count ),  
							"recordsFiltered" => intval( $total_filtered_count ), 
							"data"            => $final_data
						);

		echo json_encode($json_data);  // send data as json format	    		
	}
	
	public function add_client_modal(){

		$this->return['success'] = TRUE;

		$this->data['currencies'] = $this->settings_model->currencies();
	
		$this->return['modal'] = $this->load->view('admin/xhr/clients/add_client_modal', $this->data, TRUE);

		$this->return['modal_id'] = "add-client-modal";

		echo json_encode($this->return);
	}

	public function add_client(){
		$this->form_validation->set_rules($this->admin_rules->add_client());

		if ($this->form_validation->run()) {

			$client_data =	[
								'client_name'		=> $this->input->post('client_name'),
								'client_address'   	=> $this->input->post('client_address'),
								'client_city'	 	=> $this->input->post('client_city'),
								'client_state'	 	=> $this->input->post('client_state'),
								'client_state_code'	=> $this->input->post('client_state_code'),
								'client_pincode'	=> $this->input->post('client_pincode'),
								'client_country'	=> $this->input->post('client_country'),
								'client_phone'	 	=> $this->input->post('client_phone'),
								'client_website'	=> $this->input->post('client_website'),
								'client_email'	 	=> $this->input->post('client_email'),
								'client_gstin'	 	=> $this->input->post('client_gstin'),
								'client_currency'	=> $this->input->post('client_currency')
			                ];

			if ($this->clients_model->add_client($client_data)) {

            	$this->return['success'] = "Client added successfully...";

				$this->return['close'] = TRUE;

				$this->return['time'] = 2000;

				$this->return['reload'] = TRUE;
            }
            else{
            	$this->return['error'] = array();
				$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
            } 

            foreach ($_POST as $post_key => $post_value) {
				$this->return['no_error'][$post_key] = NULL;
			}               
		}
		else{
			$this->return['error'] = array();
			$this->return['common_error_msg'] = "Please complete fields correctly...";

			foreach ($_POST as $each_post_key => $each_post_val) {
				$this->return['error'][$each_post_key] = form_error($each_post_key);
			}
		}

		echo json_encode($this->return);
	}

	public function edit_client_modal(){

    	$_client_id 	= $this->input->post('_client_id');
		$client_data 	= $this->clients_model->clients(['_client_id' => $_client_id]);

		if (!$client_data) {
			$this->return['error'] = "Invalid data given";
		}
		else{
			$this->return['success'] 	= TRUE;
			$this->data['client_data'] 	= $client_data;
			$this->data['currencies'] 	= $this->settings_model->currencies();
			$this->return['modal'] 		= $this->load->view('admin/xhr/clients/edit_client_modal', $this->data, TRUE);
			$this->return['modal_id'] 	= "edit-client-modal";
		}

		//echo json_encode($this->return);
	}

	public function edit_client(){

    	$_client_id = $this->input->post('_client_id');
		$client_data = $this->clients_model->clients(['_client_id' => $_client_id]);

		if (!$client_data) {
			$this->return['error'] = array();
			$this->return['common_error_msg'] = "Invalid data given";
		}
		else{
			$this->form_validation->set_rules($this->admin_rules->add_client());

			if ($this->form_validation->run()) {

				$upd_data =	[
								'client_name'		=> $this->input->post('client_name'),
								'client_address'   	=> $this->input->post('client_address'),
								'client_city'	 	=> $this->input->post('client_city'),
								'client_state'	 	=> $this->input->post('client_state'),
								'client_state_code'	=> $this->input->post('client_state_code'),
								'client_pincode'	=> $this->input->post('client_pincode'),
								'client_country'	=> $this->input->post('client_country'),
								'client_phone'	 	=> $this->input->post('client_phone'),
								'client_website'	=> $this->input->post('client_website'),
								'client_email'	 	=> $this->input->post('client_email'),
								'client_gstin'	 	=> $this->input->post('client_gstin'),
								'client_currency'	=> $this->input->post('client_currency')
			                ];

                if ($this->clients_model->update_client($_client_id, $upd_data)) {

	            	//$this->return['success'] = "Client updated successfully...";

					//$this->return['close'] = TRUE;

					$this->return['time'] = 2000;

				    $this->return['reload'] = TRUE;
	            }
	            else{
	            	$this->return['error'] = array();
					$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
	            }

	            foreach ($_POST as $post_key => $post_value) {
					$this->return['no_error'][$post_key] = NULL;
				}
			}
			else{

				$this->return['error'] = array();
				$this->return['common_error_msg'] = "Please complete fields correctly...";
				foreach ($_POST as $each_post_key => $each_post_val) {
					$this->return['error'][$each_post_key] = form_error($each_post_key);
				}
			}	
		}

		echo json_encode($this->return);
    }


    public function client_contacts_list(){

		$request_data = $_REQUEST;

		$limit  = isset($request_data['length']) ? $request_data['length'] : 10;
		$offset = isset($request_data['start'])  ? $request_data['start']  : 0;

    	$_client_id   = $this->input->get('_client_id');

    	// getting total number records without any search
		$data = $this->clients_model->client_users([
			                                	'limit'    		=> 	$limit, 
			                                	'offset'   		=> 	$offset,
			                                	'_client_id'	=>	$_client_id
	                                        ]);

		$total_row_count = $this->clients_model->client_users([	'count' 		=>  1,
			                                					'_client_id'	=>	$_client_id ]);	
		
		$total_filtered_count = $total_row_count;

		if (isset($request_data['search']['value']) && !empty($request_data['search']['value'])) {

			$data = $this->clients_model->client_users([
						             	           	'like'     		=> 	$request_data['search']['value'],
						             	           	'limit'    		=> 	$limit,
						             	           	'offset'  		=> 	$offset,
			                                		'_client_id'	=>	$_client_id
							             	    ]);

			$total_filtered_count = count($this->clients_model
				                               ->client_users([
                                                            'like'     		=> 	$request_data['search']['value'],
                                                            'order_by' 		=> 	$order_by,
			                                				'_client_id'	=>	$_client_id
                                                        ]));
		}

		$final_data = [];

		if ($data) {
			foreach ($data as $i=> $each_data) {

				$nested_data = [];

				$nested_data[] = ($offset)+($i+1); 

				$nested_data[] = $each_data->user_first_name.' '.$each_data->user_last_name;

				$nested_data[] = $each_data->user_job_title;

				$nested_data[] = $each_data->user_email;

				$nested_data[] = $each_data->user_mobile;

				$nested_data[] = $each_data->user_skype_id;

				$nested_data[] ="<ul class=\"nav navbar-nav navbar-right\">
                                    <li class=\"dropdown\">
	                    				<a href=\"javascript:void(0);\" class=\"dropdown-toggle\" 
	                    				   data-toggle=\"dropdown\">
	                    				   <i class=\"fa fa-cog\" ></i><b class=\"caret\"></b>
	                    				</a>
	                    				<ul class=\"dropdown-menu\">
	                      				 	<li>
	                      				    	<a href='javascript:void(0);' class='fa fa-pencil' style='color:#007bff;'
	                      				        	onclick=\"open_modal('clients/edit-client-contact', 
	                      				        	'_user_id=".$each_data->_user_id."&_client_id=".$_client_id."');\"> Edit
										    	</a>
										  	</li>
										  	<li>
	                      				    	<a href='javascript:void(0);' class='fa fa-trash' style='color:#dc3545;'
	                      				        	onclick=\"open_modal('clients/delete-client', 
	                      				        	'_user_id=".$each_data->_user_id."');\"> Delete
										     	</a>
										  	</li>
	                    				</ul>
                  					</li>
                  				</ul>";

                $final_data[] =  $nested_data;  				
			}
		}

		$json_data = array(
							"draw"            => intval(isset($request_data['draw']) ? $request_data['draw'] : 1),   
							"recordsTotal"    => intval( $total_row_count ),  
							"recordsFiltered" => intval( $total_filtered_count ), 
							"data"            => $final_data
						);

		echo json_encode($json_data);  // send data as json format
    }

    public function add_client_contact_modal(){

    	$_client_id 	= $this->input->post('_client_id');
		$client_data 	= $this->clients_model->clients(['_client_id' => $_client_id]);

		if (!$client_data) {
			$this->return['error'] = "Invalid data given";
		}
		else{
			$this->return['success'] 	= TRUE;
			$this->data['client_data'] 	= $client_data;
			$this->return['modal'] 		= $this->load->view('admin/xhr/clients/add_client_contact_modal', $this->data, TRUE);
			$this->return['modal_id'] 	= "add-client-contact-modal";
		}

		echo json_encode($this->return);
    }

    public function add_client_contact(){
    	$this->load->model('user_model');

    	$_client_id 	= $this->input->post('_client_id');
		$client_data 	= $this->clients_model->clients(['_client_id' => $_client_id]);

		if (!$client_data) {
			$this->return['error'] = array();
			$this->return['common_error_msg'] = "Invalid data given";
		}
		else{
			if(!$this->input->post('user_gender')){
				$_POST['user_gender'] = NULL;
			}
			$this->form_validation->set_rules($this->admin_rules->add_client_contact());

			if ($this->form_validation->run()) {
				$client_user_data = [
										'user_first_name'		=>	$this->input->post('user_first_name'),
										'user_last_name'		=>	$this->input->post('user_last_name'),
										'user_mobile'			=>	$this->input->post('user_mobile'),
										'user_email'			=>	$this->input->post('user_email'),
										'user_skype_id'			=>	$this->input->post('user_skype_id'),
										'user_job_title'		=>	$this->input->post('user_job_title'),
										'user_gender'			=>	$this->input->post('user_gender'),
										'user_password'			=>	$this->input->post('user_password'),
										'user_role_id'			=>	10
									];
				if ($_user_id = $this->user_model->add_user($client_user_data)) {

					$client_user = 	[
										'cu_user_id'			=>	$_user_id,
										'cu_client_id'			=>	$_client_id
									];
					$this->clients_model->add_client_user($client_user);

	            	$this->return['success'] = "Contact user added successfully...";
					$this->return['close'] = TRUE;
	            }
	            else{
	            	$this->return['error'] = array();
					$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
	            }

	            foreach ($_POST as $post_key => $post_value) {
					$this->return['no_error'][$post_key] = NULL;
				}
			}else{

				$this->return['error'] = array();
				$this->return['common_error_msg'] = "Please complete fields correctly...";
				foreach ($_POST as $each_post_key => $each_post_val) {
					$this->return['error'][$each_post_key] = form_error($each_post_key);
				}
			}
		}

		echo json_encode($this->return);
    }

    public function edit_client_contact_modal(){

    	$_client_id 	= $this->input->post('_client_id');
    	$_user_id		= $this->input->post('_user_id');
		$contact_data 	= $this->clients_model->client_users([
																'_client_id' 	=> 	$_client_id,
																'_user_id'		=>	$_user_id
															]);

		if (!$contact_data) {
			$this->return['error'] = "Invalid data given";
		}
		else{
			$this->return['success'] 	= TRUE;
			$this->data['contact_data'] = $contact_data;
			$this->return['modal'] 		= $this->load->view('admin/xhr/clients/edit_client_contact_modal', $this->data, TRUE);
			$this->return['modal_id'] 	= "edit-client-contact-modal";
		}

		echo json_encode($this->return);
    }

    public function edit_client_contact(){

    	$_client_id 	= $this->input->post('_client_id');
    	$_user_id		= $this->input->post('_user_id');
		$contact_data 	= $this->clients_model->client_users([
																'_client_id' 	=> 	$_client_id,
																'_user_id'		=>	$_user_id
															]);

		if (!$contact_data) {
			$this->return['error'] = array();
			$this->return['common_error_msg'] = "Invalid data given";
		}
		else{
			
		}

		echo json_encode($this->return);
    }

    public function projects(){
    	$_client_id 	= $this->input->post('_client_id');
		$client_data 	= $this->clients_model->clients(['_client_id' => $_client_id]);

		if (!$client_data) {
			$this->return['error'] = "Invalid data given";
		}else{
			$this->return['success'] = TRUE;

			$this->return['html_id'] = "projects";

			$this->data['client_data'] = $client_data;

			$this->return['html'] = $this->load->view('admin/xhr/clients/projects', $this->data, TRUE);
		}

		echo json_encode($this->return);
    }

    public function project_list($_client_id){

    	$this->load->model('projects_model');
    	$request_data = $_REQUEST;

		$limit  = isset($request_data['length']) ? $request_data['length'] : 10;
		$offset = isset($request_data['start'])  ? $request_data['start']  : 0;

		// getting total number records without any search
		$data = $this->projects_model->projects([
					                                	'limit'    		=> 	$limit, 
					                                	'offset'   		=> 	$offset,
					                                	'_client_id'	=>	$_client_id
	                                        	]);

		$total_row_count = $this->projects_model->projects([
														'count' 		=>  1,
					                                	'_client_id'	=>	$_client_id
					                                ]);	
		
		$total_filtered_count = $total_row_count;

		if (isset($request_data['search']['value']) && !empty($request_data['search']['value'])) {

			$data = $this->projects_model->projects([
							             	           	'like'     		=> 	$request_data['search']['value'],
							             	           	'limit'    		=> 	$limit,
							             	           	'offset'   		=> 	$offset,
				                                		'_client_id'	=>	$_client_id
							             	    	]);

			$total_filtered_count = count($this->projects_model
				                               ->projects([
                                                        'like'     		=> 	$request_data['search']['value'],
                                                        'order_by' 		=> 	$order_by,
		                                				'_client_id'	=>	$_client_id
                                                    ]));
		}

		$final_data = [];

		if ($data) {
			foreach ($data as $i=> $each_data) {

				$nested_data = [];

				$nested_data[] = ($offset)+($i+1);

				$title_section = '<a href="'.base_url("projects/details/".$each_data->_project_id).'">'.$each_data->project_title.'<br>';
				if($each_data->project_skills){
					$skill_names = skills_by_ids($each_data->project_skills);
					$skill_aray = explode(',', $skill_names);
					foreach($skill_aray as $skill_name){
						$title_section .= '<span class="badge badge-primary text-center">'.$skill_name.'</span>';
					}
				}
				$title_section .= '</a>';

				$nested_data[] = $title_section;

				$nested_data[] = $each_data->project_price;

				$nested_data[] = $each_data->project_start_date;

				$nested_data[] = $each_data->project_deadline;

				$nested_data[] = project_status($each_data->project_status,TRUE);

				$nested_data[] ="<ul class=\"nav navbar-nav navbar-right\">
                                    <li class=\"dropdown\">
	                    				<a href=\"javascript:void(0);\" class=\"dropdown-toggle\" 
	                    				   data-toggle=\"dropdown\">
	                    				   <i class=\"fa fa-cog\" ></i><b class=\"caret\"></b>
	                    				</a>
	                    				<ul class=\"dropdown-menu\">
	                      				 	<li>
	                      				    	<a href='javascript:void(0);' class='fa fa-pencil' style='color:#007bff;'
	                      				        	onclick=\"open_modal('projects/edit-project', 
	                      				        	'_project_id=".$each_data->_project_id."');\"> Edit
										    	</a>
										  	</li>
										  	
	                    				</ul>
                  					</li>
                  				</ul>";

                $final_data[] =  $nested_data;  				
			}
		}

		$json_data = array(
							"draw"            => intval(isset($request_data['draw']) ? $request_data['draw'] : 1),   
							"recordsTotal"    => intval( $total_row_count ),  
							"recordsFiltered" => intval( $total_filtered_count ), 
							"data"            => $final_data
						);

		echo json_encode($json_data);  // send data as json format
    }

}