<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class General extends MY_Controller {

	public function __construct(){
		parent::__construct();

		if (!$this->input->is_ajax_request()) {
			$this->load->error_404($this->data);
		}

		$this->load->library('form_validation_rules/admin_rules');
	}






	/********************************Login Start ***********************************/
	public function login(){

		$this->form_validation->set_rules($this->admin_rules->login());


		if ($this->form_validation->run()) {

			$this->load->model('user_model');

			$user_email    = $this->input->post('user_email');
			$user_password = $this->input->post('user_password');

			if ($user_data = $this->user_model->login($user_email, $user_password)) {

				$this->session->set_userdata('login', TRUE);

				$this->session->set_userdata('_user_id', $user_data->_user_id);

				$this->session->set_userdata('user_role_id', $user_data->user_role_id);

				$this->session->set_userdata('user_first_name', $user_data->user_first_name);
				$this->session->set_userdata('user_last_name', $user_data->user_last_name);
				$this->session->set_userdata('user_image', $user_data->user_image);

				$this->session->set_userdata('user_gender', $user_data->user_gender);

				$this->session->set_userdata('user_job_title', $user_data->user_job_title);

				$this->session->set_userdata('_token_id', $user_data->_token_id);
				$this->session->set_userdata('token_value', $user_data->token_value);


				$current_fin_year = $this->settings_model->current_fin_year();

				if ($current_fin_year) {
					$this->session->set_userdata('_fin_year_id', $current_fin_year->_fin_year_id);
					$this->session->set_userdata('fin_year', $current_fin_year->fin_year);
				}


				$this->return['success'] = "Login Successfully...";

				$this->return['redirect'] = site_url('dashboard');

				$this->return['time'] = 2000;
			}
			else{
            	$this->return['error'] = array();

				$this->return['common_error_msg'] = "Credentials not matched !";
            }	

			foreach ($_POST as $post_key => $post_value) {
				$this->return['no_error'][$post_key] = NULL;
			}
		}
		else{

			$this->return['error'] = array();

			$this->return['common_error_msg'] = "Please complete fields correctly...";

			foreach ($_POST as $each_post_key => $each_post_val) {
				$this->return['error'][$each_post_key] = form_error($each_post_key);
			}
		}

		echo json_encode($this->return);	
	}
	/********************************Login End ***********************************/




	/********************************Logout Start ***********************************/
	public function logout(){

		$this->load->model('user_model');

		if ($this->user_model->logout($this->session->userdata('token_value'))) {
			
			$this->return['success'] = "Logout Successfully";

			$this->return['redirect'] = site_url('login');

			$this->return['time'] = 2000;
		}
		else{
			$this->return['error'] = "Some problems occured...try again later.";
		}

		echo json_encode($this->return);
	}
	/********************************Logout End ***********************************/



	/********************************Change Password Modal Start *********************************/
	public function change_password_modal(){

		$this->return['success'] = TRUE;
	
		$this->return['modal'] = $this->load->view('admin/xhr/general/change_password_modal',$this->data,TRUE);

		$this->return['modal_id'] = "change-password-modal";

		echo json_encode($this->return);
	}
	/********************************Change Password Modal End *********************************/




	/********************************Change Password Start *********************************/
	public function change_password(){

		$_user_id = $this->session->userdata('_user_id');

		$user_enc_pass = $this->db->select('user_password')
		                          ->from('users')
		                          ->where('_user_id', $_user_id)
		                          ->get()
		                          ->row()
		                          ->user_password;

        
		$this->form_validation->set_rules($this->admin_rules->update_my_password($user_enc_pass));


		if ($this->form_validation->run()) {

			$upd_user_data = [
								'user_password' => $this->input->post('new_password')
			                 ];

            $this->load->model('user_model');


            if ($this->user_model->update_user($_user_id, $upd_user_data)) {

            	$this->return['success'] = "Password updated successfully...";

            	$this->return['reload'] = TRUE;

            	$this->return['time'] = 2000;

				$this->return['close'] = TRUE;
            }
            else{
            	$this->return['error'] = array();

				$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
            }

			foreach ($_POST as $post_key => $post_value) {
				$this->return['no_error'][$post_key] = NULL;
			}
		}
		else{

			$this->return['error'] = array();

			$this->return['common_error_msg'] = "Please complete fields correctly...";

			foreach ($_POST as $each_post_key => $each_post_val) {
				$this->return['error'][$each_post_key] = form_error($each_post_key);
			}
		}


		echo json_encode($this->return);	
	}	
	/********************************Change Password End *********************************/



	/********************************Unread Notifications Count Start *********************************/
	public function unread_notification_count(){

		$this->load->model('notification_model');

		$token_value = $this->session->userdata('token_value');

		$this->load->model('user_model');

		if ($this->user_model->verify_user_token($token_value)) {

			$unread_notification_count = 
		    $this->notification_model->notifications($this->session->userdata('_user_id'), ['count' => TRUE, 'notification_is_read' => 0]);


		    $this->return['notifications'] = 
		    $this->notification_model->notifications($this->session->userdata('_user_id'), ['notification_is_read' => 0]); 

		    $this->return['success'] = TRUE;

		    $this->return['unread_notification_count'] = $unread_notification_count;
		}
		else{
			$this->return['error'] = "Not loggged in !";
		}

		echo json_encode($this->return);
	}
	/********************************Unread Notifications Count End ************************************/




	/********************************Load Unread Notifications Start *********************************/
	public function load_unread_notifications(){

		$this->load->model('notification_model');

		$this->data['unread_notification_count'] = 
		$this->notification_model->notifications($this->session->userdata('_user_id'), ['count' => TRUE, 'notification_is_read' => 0]);

		$this->data['notifications'] = $this->notification_model->notifications($this->session->userdata('_user_id'), ['limit' => 3]);


		$this->db->where('notification_to_user_id', $this->session->userdata('_user_id'))
		         ->where('notification_is_read', 0)          
		         ->update('notifications', ['notification_is_read' => 1, 'notification_read_time' => date('Y-m-d H:i:s')]);

		$this->return['success'] = TRUE;
	
		$this->return['html'] = $this->load->view('admin/xhr/general/load_unread_notifications', $this->data, TRUE);

		echo json_encode($this->return);
	}
	/********************************Load Unread Notifications End ***********************************/



	/********************************Load Desktop Notification Start *********************************/
	public function load_desktop_notification(){

		$this->load->model('notification_model');

		$notifications = $this->notification_model->notifications($this->session->userdata('_user_id'), ['notification_is_read' => 0]);

		$this->return['notifications'] = $notifications;

		echo json_encode($this->return);
	}
	/********************************Load Desktop Notification End ***********************************/



	/******************************* Read Notification Start ***********************************/
	public function read_notification(){

		$_notification_id = $this->input->post('_notification_id');

		$this->db->where('notification_to_user_id', $this->session->userdata('_user_id'))
		         ->where('_notification_id', $_notification_id)          
		         ->update('notifications', ['notification_is_read' => 1, 'notification_read_time' => date('Y-m-d H:i:s')]);
        
        $this->return['success'] = "Notification read successfully.";		         

        echo json_encode($this->return);		         
	}
	/******************************* Read Notification End ***********************************/



	/******************************* Update Profile Picture Modal Start ***********************************/
	public function update_profile_picture_modal(){

		$this->return['success'] = TRUE;
	
		$this->return['modal'] = $this->load->view('admin/xhr/general/update_profile_picture_modal',$this->data,TRUE);

		$this->return['modal_id'] = "update-profile-picture-modal";

		echo json_encode($this->return);
	}
	/******************************* Update Profile Picture Modal End ***********************************/



	/******************************* Update Profile Picture Start ***********************************/
	public function update_profile_picture(){

		$token_value = $this->session->userdata('token_value');

		$this->load->model('user_model');

		if ($this->user_model->verify_user_token($token_value)) {

			$upload_dir = "assets/images/upload/profile-pic/";

			$this->load->library('upload', image_upload_option($upload_dir), 'pic_upload'); 
        	$this->pic_upload->initialize(image_upload_option($upload_dir));

        	$upload_pic = FALSE;
        	$pic_data = NULL;

        	/*if (!$this->session->tempdata('pic_data')) {
	        	$upload_pic = $this->pic_upload->do_upload('user_image');

	        	if ($upload_pic) {
					$pic_data = $this->pic_upload->data();
				}
	        }*/


	        if ($upload_pic = $this->pic_upload->do_upload('user_image')) {

	        	if ($pic_data = $this->pic_upload->data()) {

	        		$upd_user_data = [ 'user_image' => $upload_dir.$pic_data['file_name'] ];

	        		 $this->load->model('user_model');


		            if ($this->user_model->update_user($this->session->userdata('_user_id'), $upd_user_data)) {

		            	$this->session->set_userdata('user_image', $upd_user_data['user_image']);

		            	$this->return['success'] = "Profile picture updated successfully...";

		            	$this->return['close'] = TRUE;

		            	$this->return['reload'] = TRUE;

		            	$this->return['time'] = 2000;

						
		            }
		            else{
		            	$this->return['error'] = array();

						$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
		            }
	        	}
	        	else{
	        		$this->return['error'] = array();

					$this->return['common_error_msg'] = "Timeout. Retry again !";
	        	}
	        	

	        	

	        	$this->return['no_error']['user_image'] = NULL; 
	        }
	        else{

				$this->return['error'] = array();

				$this->return['common_error_msg'] = "Please complete fields correctly...";

				$this->return['error']['user_image']  = $this->pic_upload->display_errors("<p style='color:red'>", "<p>");
			}	
	        
		}	
		else{

			$this->return['error'] = array();

			$this->return['common_error_msg'] = "Not loggged in !";
		}

		echo json_encode($this->return);
	}
	/******************************* Update Profile Picture End ***********************************/




}