<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Notes extends MY_Controller {

	public function __construct(){
		parent::__construct();

		if (!$this->input->is_ajax_request()) {
			$this->load->error_404($this->data);
		}

		$this->load->library('form_validation_rules/admin_rules');
	}





	/********************************Add Note Modal Start ***********************************/
	public function add_note_modal(){

		$this->return['success'] = TRUE;
	
		$this->return['modal'] = $this->load->view('admin/xhr/notes/add_note_modal', $this->data, TRUE);

		$this->return['modal_id'] = "add-note-modal";

		echo json_encode($this->return);
	}
	/********************************Add Note Modal End *************************************/




	/********************************Add Note Start ***********************************/
	public function add_note(){

		$this->form_validation->set_rules($this->admin_rules->add_note());


		if ($this->form_validation->run()) {

			$add_note_data = [
								'unote_user_id' => $this->session->userdata('_user_id'),
								'unote_title'   => $this->input->post('unote_title'),
								'unote_desc'    => $this->input->post('unote_desc')
			                 ];


			$this->load->model('note_model'); 
			

			if ($this->note_model->add_note($add_note_data)) {

            	$this->return['success'] = "Note added successfully...";

				$this->return['close'] = TRUE;
            }
            else{
            	$this->return['error'] = array();

				$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
            } 


            foreach ($_POST as $post_key => $post_value) {
				$this->return['no_error'][$post_key] = NULL;
			}               
		}
		else{

			$this->return['error'] = array();

			$this->return['common_error_msg'] = "Please complete fields correctly...";

			foreach ($_POST as $each_post_key => $each_post_val) {
				$this->return['error'][$each_post_key] = form_error($each_post_key);
			}
		}

		echo json_encode($this->return);	
    }
	/********************************Add Note End ***********************************/





	/******************************* Note List Start ***********************************/
	public function note_list(){

		$this->load->model('note_model');

		$request_data = $_REQUEST;

		$limit  = isset($request_data['length']) ? $request_data['length'] : 10;
		$offset = isset($request_data['start'])  ? $request_data['start']  : 0;


		// getting total number records without any search
		$data = $this->note_model->note_list([
			                                   'limit'    => $limit, 
			                                   'offset'   => $offset,
			                                   '_user_id' => $this->session->userdata('_user_id')
	                                         ]);

		$total_row_count = $this->note_model->note_list([ 
			                                                'count' =>  1,
			                                                '_user_id' => $this->session->userdata('_user_id')
			                                            ]);	
		
		$total_filtered_count = $total_row_count;


		if (isset($request_data['search']['value']) && !empty($request_data['search']['value'])) {

			$data = $this->note_model->note_list([
						             	           'like'     => $request_data['search']['value'],
						             	           'limit'    => $limit,
						             	           'offset'   => $offset,
						             	           '_user_id' => $this->session->userdata('_user_id')
							             	     ]);

			$total_filtered_count = count($this->note_model
				                               ->note_list([
                                                                'like'     => $request_data['search']['value'],
                                                                'order_by' => $order_by,
                                                                '_user_id' => $this->session->userdata('_user_id')
                                                           ]));	
			
		}



		$final_data = [];


		if ($data) {
			foreach ($data as $i=> $each_data) {

				$nested_data = [];

				$nested_data[] = ($offset)+($i+1); 

				$nested_data[] = $each_data->unote_title;

				$nested_data[] = formatDate($each_data->unote_create_time);


				$nested_data[] = "<ul class=\"nav navbar-nav navbar-right\">
                                    <li class=\"dropdown\">
                    				<a href=\"javascript:void(0);\" class=\"dropdown-toggle\" 
                    				   data-toggle=\"dropdown\">
                    				   <i class=\"fa fa-cog\" ></i><b class=\"caret\"></b>
                    				</a>
                    				<ul class=\"dropdown-menu\">
                      				  <li>
                      				     <a href='javascript:void(0);' class='fa fa-pencil' style='color:#007bff;'
                      				        onclick=\"open_modal('notes/edit-note', 
                      				        '_unote_id=".$each_data->_unote_id."');\"> Edit
									     </a>
									  </li>
									  <li>
                      				     <a href='javascript:void(0);' class='fa fa-trash' style='color:#dc3545;'
                      				        onclick=\"open_modal('notes/delete-note', 
                      				        '_unote_id=".$each_data->_unote_id."');\"> Delete
									     </a>
									  </li>
                    				</ul>
                  					</li>
                  				</ul>"; 


                $final_data[] =  $nested_data;  				
			}
		}


		$json_data = array(
							"draw"            => intval(isset($request_data['draw']) ? $request_data['draw'] : 1),   
							"recordsTotal"    => intval( $total_row_count ),  
							"recordsFiltered" => intval( $total_filtered_count ), 
							"data"            => $final_data
						);

		echo json_encode($json_data);  // send data as json format	    		
	}
	/******************************* Note List End *************************************/





	/********************************Edit Note Modal Start ***********************************/
	public function edit_note_modal(){

		$this->load->model('note_model');

    	$_unote_id = $this->input->post('_unote_id');

		$note_data = $this->note_model->note_list(['_unote_id' => $_unote_id]);

		if (!$note_data) {
			
			$this->return['error'] = "Invalid data given";

		}
		else{
			
			$this->return['success'] = TRUE;

			$this->data['note_data'] = $note_data;
	
			$this->return['modal'] = $this->load->view('admin/xhr/notes/edit_note_modal', $this->data, TRUE);

			$this->return['modal_id'] = "edit-note-modal";
		}

		echo json_encode($this->return);
	}
	/********************************Edit Note Modal End ***********************************/




	/********************************Edit Note Start ***********************************/
	public function edit_note(){

		$this->load->model('note_model');

    	$_unote_id = $this->input->post('_unote_id');

		$note_data = $this->note_model->note_list(['_unote_id' => $_unote_id]);

		if (!$note_data) {
			
			$this->return['error'] = array();

			$this->return['common_error_msg'] = "Invalid data given";

		}
		else{
			$this->form_validation->set_rules($this->admin_rules->add_note());


			if ($this->form_validation->run()) {

				$upd_note_data = [
									'unote_title'   => $this->input->post('unote_title'),
									'unote_desc'    => $this->input->post('unote_desc')
				                 ];

                if ($this->note_model->update_note($_unote_id, $upd_note_data)) {

	            	$this->return['success'] = "Note updated successfully...";

					$this->return['close'] = TRUE;
	            }
	            else{
	            	$this->return['error'] = array();

					$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
	            } 


	            foreach ($_POST as $post_key => $post_value) {
					$this->return['no_error'][$post_key] = NULL;
				}

			}
			else{

				$this->return['error'] = array();

				$this->return['common_error_msg'] = "Please complete fields correctly...";

				foreach ($_POST as $each_post_key => $each_post_val) {
					$this->return['error'][$each_post_key] = form_error($each_post_key);
				}
			}	
		}

		echo json_encode($this->return);
    }
	/********************************Edit Note End ***********************************/




	/********************************Delete Note Modal Start ***********************************/
	public function delete_note_modal(){

		$this->load->model('note_model');

    	$_unote_id = $this->input->post('_unote_id');

		$note_data = $this->note_model->note_list(['_unote_id' => $_unote_id]);


		if (!$note_data) {
			
			$this->return['error'] = "Invalid data given";

		}
		else{
			$this->return['success'] = TRUE;

			$this->return['modal_id'] = "delete-note-modal";

			$data['modal_id'] = "delete-note-modal";

			$data['modal_title'] = "Delete Note";

			$data['modal_body'] = "Are you sure to delete this note ?";

			$data['modal_link'] = "'notes/delete-note'";

			$data['modal_data'] = "'_unote_id=$_unote_id'";

			$this->return['modal'] = $this->load->view('admin/xhr/confirm_delete_modal', $data, TRUE);
		}


		echo json_encode($this->return);
	}
	/********************************Delete Note Modal End ***********************************/



	/********************************Delete Note Start ***********************************/
	public function delete_note(){

		$this->load->model('note_model');

    	$_unote_id = $this->input->post('_unote_id');

		$note_data = $this->note_model->note_list(['_unote_id' => $_unote_id]);


		if (!$note_data) {
			
			$this->return['error'] = "Invalid data given";
		}
		else{
			if ($this->note_model->update_note($_unote_id, ['unote_is_delete' => 1])) {

				$this->return['success'] = "Note deleted successfully...";

				$this->return['close'] = TRUE;

				$this->return['modal_id'] = "delete-note-modal";
			}
			else{
				$this->return['error'] = "Some Problems Occured...Try Again Later";
			}
		}

		echo json_encode($this->return);
	}
	/********************************Delete Note End ***********************************/






}	