<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Notifications extends MY_Controller {

	public function __construct(){
		parent::__construct();

		if (!$this->input->is_ajax_request()) {
			$this->load->error_404($this->data);
		}

		$this->load->library('form_validation_rules/admin_rules');

		$this->load->model('notification_model');
	}




	/******************************* Notification List Start ***********************************/
	public function notification_list(){

		$request_data = $_REQUEST;

		$limit  = isset($request_data['length']) ? $request_data['length'] : 10;
		$offset = isset($request_data['start'])  ? $request_data['start']  : 0;


		// getting total number records without any search
		$data = $this->notification_model->notifications($this->session->userdata('_user_id'),
						                                    [
							                                   'limit'    => $limit, 
							                                   'offset'   => $offset
					                                        ]
					                                    );

		$total_row_count = $this->notification_model->notifications($this->session->userdata('_user_id'),[  'count' =>  1]);	
		
		$total_filtered_count = $total_row_count;


		if (isset($request_data['search']['value']) && !empty($request_data['search']['value'])) {

			$data = $this->notification_model->notifications($this->session->userdata('_user_id'),
						                                     [
									             	           'like'     => $request_data['search']['value'],
									             	           'limit'    => $limit,
									             	           'offset'   => $offset
										             	     ]);

			$total_filtered_count = count($this->notification_model
				                               ->notifications($this->session->userdata('_user_id'),
				                                         	  [
                                                                'like'     => $request_data['search']['value'],
                                                                'order_by' => $order_by
                                                              ]));	
			
		}



		$final_data = [];


		if ($data) {
			foreach ($data as $i=> $each_data) {

				$nested_data = [];

				$nested_data[] = ($offset)+($i+1); 

				$action_type =  $each_data->notification_action_type=="link" ? 
				                "href=\"".site_url($each_data->notification_modal_link)."\"  
				                 target=\"".$each_data->notification_modal_link_target."\"" :
				                "onclick=\"open_modal('".$each_data->notification_modal_id."', '".$each_data->notification_modal_data."');\" 
				                 href=\"javascript:void;\" "; 

				$style = $each_data->notification_is_read==0 ? " style='font-weight:bold;' " : NULL;                 

				$nested_data[] = "<a  ".$style." ".$action_type." >".
				                    $each_data->notification_title.
				                 "</a>";

				$nested_data[] = formatDate($each_data->notification_create_time);

				$final_data[] =  $nested_data;
			}
		}


		$this->db->where('notification_to_user_id', $this->session->userdata('_user_id'))
		         ->where('notification_is_read', 0)          
		         ->update('notifications', ['notification_is_read' => 1, 'notification_read_time' => date('Y-m-d H:i:s')]);


		$json_data = array(
							"draw"            => intval(isset($request_data['draw']) ? $request_data['draw'] : 1),   
							"recordsTotal"    => intval( $total_row_count ),  
							"recordsFiltered" => intval( $total_filtered_count ), 
							"data"            => $final_data
						);

		echo json_encode($json_data);  // send data as json format			
	}
	/******************************* Notification List End *************************************/



	


}	