<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Salary extends MY_Controller {

	public function __construct(){
		parent::__construct();

		if (!$this->input->is_ajax_request()) {
			$this->load->error_404($this->data);
		}

		$this->load->library('form_validation_rules/admin_rules');

		$this->load->model('salary_model');
	}




	/******************************* Salary Slips Start ***********************************/
	public function salary_slips(){

		$ctrl = $this->input->get('ctrl');

		$_user_id = $this->input->get('_user_id');

		if (!$_user_id && !in_array($this->session->userdata('user_role_id'), [1,3])) {
			$_user_id = $this->session->userdata('_user_id');
		}

		$request_data = $_REQUEST;

		$limit  = isset($request_data['length']) ? $request_data['length'] : 10;
		$offset = isset($request_data['start'])  ? $request_data['start']  : 0;


		// getting total number records without any search
		$data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
				                                    [
					                                   'limit'    => $limit, 
					                                   'offset'   => $offset,
					                                   '_user_id' => $_user_id
			                                        ]
			                                      );

		$total_row_count = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
				                                                  [  'count' =>  1, '_user_id' => $_user_id]);	
		
		$total_filtered_count = $total_row_count;



		if (isset($request_data['search']['value']) && !empty($request_data['search']['value'])) {

			$data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
						                                     [
									             	           'like'     => $request_data['search']['value'],
									             	           'limit'    => $limit,
									             	           'offset'   => $offset,
									             	           '_user_id' => $_user_id
										             	     ]);

			$total_filtered_count = count($this->salary_model
				                               ->salary_list($this->session->userdata('_fin_year_id'),
				                                         	  [
                                                                'like'     => $request_data['search']['value'],
                                                                'order_by' => $order_by,
                                                                '_user_id' => $_user_id
                                                              ]));	
			
		}



		$final_data = [];


		if ($data) {
			foreach ($data as $i=> $each_data) {

				$nested_data = [];

				$nested_data[] = ($offset)+($i+1); 


				if ($ctrl=="salary" && in_array($this->session->userdata('user_role_id'), [1,3])) {
					$nested_data[] = "<a href=\"../team-members/member-details/".$each_data->_user_id."\">
					                     <img src=\"".user_img($each_data->user_image, $each_data->user_gender)."\" 
					                          style=\"height:30px; width:30px;\" class=\"img-circle\">".
					                      $each_data->user_first_name." ".$each_data->user_last_name.
					                 "</a>";
				}


				$nested_data[] = date("M, Y", strtotime($each_data->salary_slip_month));


				if ($each_data->salary_slip_is_generated==1) {

					$nested_data[] = "<span class=\"label label-success\">Generated</span>"; 
				}
				else{
					$nested_data[] = "<span class=\"label label-danger\">Not Generated</span>"; 
				}


                if (in_array($this->session->userdata('user_role_id'), [1,3]) && $each_data->salary_slip_is_generated==0) {


                    $nested_data[] = "<ul class=\"nav navbar-nav navbar-right\">
	                                    <li class=\"dropdown\">
	                    				<a href=\"javascript:void(0);\" class=\"dropdown-toggle\" 
	                    				   data-toggle=\"dropdown\">
	                    				   <i class=\"fa fa-cog\" ></i><b class=\"caret\"></b>
	                    				</a>
	                    				<ul class=\"dropdown-menu\">
	                      				  <li>
	                      				     <a href='javascript:void(0);' class='fa fa-pencil' style='color:#007bff;'
		                  				        onclick=\"open_modal('salary/edit-salary-slip', 
		                  				        '_salary_slip_id=".$each_data->_salary_slip_id."');\"> Edit
										     </a>
										  </li>
										  <li>
	                      				     <a href='javascript:void(0);' class='fa fa-check' style='color:#5CB85C;'
	                      				        onclick=\"open_modal('salary/generate-salary-slip', 
	                      				        '_salary_slip_id=".$each_data->_salary_slip_id."');\"> Generate PDF
										     </a>
										  </li>
	                    				</ul>
	                  					</li>
	                  				</ul>";

                }
                elseif($each_data->salary_slip_is_generated==1){

                	$nested_data[] = "<a href='javascript:void(0);' class='fa fa-eye' style='color:#007bff;' title='View Salary Slip'
                  				        onclick=\"execute('salary/view-salary-slip',
                  				        '_salary_slip_id=".$each_data->_salary_slip_id."');\"> View
								     </a>";
                }
                else{
                	$nested_data[] = "";
                }	



	            $final_data[] =  $nested_data;      				
			}
		}


		$json_data = array(
							"draw"            => intval(isset($request_data['draw']) ? $request_data['draw'] : 1),   
							"recordsTotal"    => intval( $total_row_count ),  
							"recordsFiltered" => intval( $total_filtered_count ), 
							"data"            => $final_data
						);

		echo json_encode($json_data);  // send data as json format				
	}
	/******************************* Salary Slips End *************************************/




	/******************************* Edit Salary Slip Modal Start ***********************************/
	public function edit_salary_slip_modal(){

		if (!in_array($this->session->userdata('user_role_id'), [1,3])) {

			$this->return['error'] = "You are not authorized to acces here !";
		}
		else{
			$_salary_slip_id = $this->input->post('_salary_slip_id');

		    $salary_data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
		    	                                     ['_salary_slip_id' => $_salary_slip_id]);


		    if (!$salary_data) {
			
				$this->return['error'] = "Invalid data given";
			}
			elseif ($salary_data->salary_slip_is_generated==1) {

				$this->return['error'] = "You can't edit salary data after salary slip generated";
			}
			else{
				$this->return['success'] = TRUE;

				$this->data['salary_data'] = $salary_data;
	
				$this->return['modal'] = $this->load->view('admin/xhr/salary/edit_salary_slip_modal', $this->data, TRUE);

				$this->return['modal_id'] = "edit-salary-slip-modal";
			}
		}

		echo json_encode($this->return); 
	}
	/******************************* Edit Salary Slip Modal End ***********************************/



	/******************************* Edit Salary Slip Start ***********************************/
	public function edit_salary_slip(){

		if (!in_array($this->session->userdata('user_role_id'), [1,3])) {

			$this->return['error'] = array();

			$this->return['common_error_msg'] = "You are not authorized to access here !";
		}
		else{
			$_salary_slip_id = $this->input->post('_salary_slip_id');

		    $salary_data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
		    	                                     ['_salary_slip_id' => $_salary_slip_id]);


		    if (!$salary_data) {
				
				$this->return['error'] = array();

				$this->return['common_error_msg'] = "Invalid data given";
			}
			elseif ($salary_data->salary_slip_is_generated==1) {

				$this->return['error'] = array();

				$this->return['common_error_msg'] = "You can't edit salary data after salary slip generated";
			}
			else{
				$this->form_validation->set_rules($this->admin_rules->edit_salary_slip($_salary_slip_id));

				if ($this->form_validation->run()) {

					$upd_salary_data = 
					[
						"salary_slip_per_month"            => $this->input->post("salary_slip_per_month"),
						"salary_slip_basic"                => $this->input->post("salary_slip_basic"),
						"salary_slip_hra"                  => $this->input->post("salary_slip_hra"),
						"salary_slip_conveyance_allowance" => $this->input->post("salary_slip_conveyance_allowance"),
						"salary_slip_special_allowance"    => $this->input->post("salary_slip_special_allowance"),
						"salary_slip_work_from_home"       => $this->input->post("salary_slip_work_from_home"),
						"salary_slip_esic_employee"        => $this->input->post("salary_slip_esic_employee"),
						"salary_slip_pf_employee"          => $this->input->post("salary_slip_pf_employee"),
						"salary_slip_esic_employer"        => $this->input->post("salary_slip_esic_employer"),
						"salary_slip_pf_employer"          => $this->input->post("salary_slip_pf_employer"),
						"salary_slip_professional_tax"     => $this->input->post("salary_slip_professional_tax"),
						"salary_slip_tds"                  => $this->input->post("salary_slip_tds")

					];


					if ($this->salary_model->update_salary($_salary_slip_id, $upd_salary_data)) {

						$this->return['success'] = "Salary slip data updated successfully...";

						$this->return['close'] = TRUE;
					}	
					else{
						$this->return['error'] = array();

						$this->return['common_error_msg'] = "Some Problems Occured...Try Again Later";
					}

					foreach ($_POST as $post_key => $post_value) {
						$this->return['no_error'][$post_key] = NULL;
					}
				}
				else{

					$this->return['error'] = array();

					$this->return['common_error_msg'] = "Please complete fields correctly...";

					foreach ($_POST as $each_post_key => $each_post_val) {
						$this->return['error'][$each_post_key] = form_error($each_post_key);
					}
				}	
			}
		}


		echo json_encode($this->return); 
	}
	/******************************* Edit Salary Slip End ***********************************/



	/******************************* Generate Salary Slip Modal Start ***********************************/
	public function generate_salary_slip_modal(){

		if (!in_array($this->session->userdata('user_role_id'), [1,3])) {

			$this->return['error'] = "You are not authorized to acces here !";
		}
		else{
			$_salary_slip_id = $this->input->post('_salary_slip_id');

		    $salary_data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
		    	                                     ['_salary_slip_id' => $_salary_slip_id]);


		    if (!$salary_data) {
			
				$this->return['error'] = "Invalid data given";
			}
			elseif ($salary_data->salary_slip_is_generated==1) {

				$this->return['error'] = "This salary slip already generated";
			}
			else{
				$this->return['success'] = TRUE;

				$this->return['modal_id'] = "generate-salary-slip-modal";

				$data['modal_id'] = "generate-salary-slip-modal";

				$data['modal_title'] = "Generate Salary Slip PDF";

				$data['modal_body'] = "Are you sure to generate salary slip pdf ? This process can't be undone.";

				$data['modal_link'] = "'salary/generate-salary-slip'";

				$data['modal_data'] = "'_salary_slip_id=$_salary_slip_id'";

				$this->return['modal'] = $this->load->view('admin/xhr/confirm_delete_modal', $data, TRUE);
			}
		}

		echo json_encode($this->return); 
	}
	/******************************* Generate Salary Slip Modal End ***********************************/



	/******************************* Generate Salary Slip Start ***********************************/
	public function generate_salary_slip(){

		if (!in_array($this->session->userdata('user_role_id'), [1,3])) {

			$this->return['error'] = "You are not authorized to acces here !";
		}
		else{
			$_salary_slip_id = $this->input->post('_salary_slip_id');

		    $salary_data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
		    	                                     ['_salary_slip_id' => $_salary_slip_id]);


		    if (!$salary_data) {
			
				$this->return['error'] = "Invalid data given";
			}
			elseif ($salary_data->salary_slip_is_generated==1) {

				$this->return['error'] = "This salary slip already generated";
			}
			else{
				$upd_salary_data = 
				[
					"salary_slip_is_generated"   => 1,
					"salary_slip_generated_time" => date('Y-m-d H:i:s'),
					"salary_slip_generated_by"   => $this->session->userdata('_user_id')

				];


				if ($this->salary_model->update_salary($_salary_slip_id, $upd_salary_data)) {

					//Send notification to team member start
					$add_notification_data = 
                    [
					   "notification_to_user_id"        => $salary_data->_user_id,
					   "notification_title"             => "Your salary slip for the month ".
					                                       date("M, Y", strtotime($salary_data->salary_slip_month)).
					                                       " has been generated",
					   "notification_from_user_id"      => $this->session->userdata('_user_id'),
					   "notification_action_type"       => "link",
					   "notification_modal_link"        => "salary/salary-slip/".url_encode($_salary_slip_id),
					   "notification_modal_link_target" => "_blank"
                    ]; 

                    $this->load->model('notification_model');

                    $this->notification_model->add_notification($add_notification_data);
					//Send notification to team member end

					$this->return['success'] = "Salary slip pdf generated successfully...";

					$this->return['close'] = TRUE;

					$this->return['modal_id'] = "generate-salary-slip-modal";
				}	
				else{
					$this->return['error'] = "Some Problems Occured...Try Again Later";					
				}
			}
		}

		echo json_encode($this->return); 
	}
	/******************************* Generate Salary Slip End ***********************************/



	/******************************* View Salary Slip Start ***********************************/
	public function view_salary_slip(){

		$_salary_slip_id = $this->input->post('_salary_slip_id');

		$salary_data = $this->salary_model->salary_list($this->session->userdata('_fin_year_id'),
		    	                                     ['_salary_slip_id' => $_salary_slip_id]);


		if (!$salary_data) {
			
			$this->return['error'] = "Invalid data given";
		}
		elseif ($salary_data->salary_slip_is_generated==0) {

			$this->return['error'] = "This salary slip not generated yet";
		}
		elseif (!in_array($this->session->userdata('user_role_id'), [1,3]) && 
		        $salary_data->_user_id!=$this->session->userdata('_user_id')) {

			$this->return['error'] = "You are not authorized to access here";
		}
		else{
			$_enc_salary_slip_id = url_encode($_salary_slip_id);

			$pdf_link = site_url("salary/salary-slip/".$_enc_salary_slip_id);

			$this->return['success'] = TRUE;

			$this->return['external_link'] = $pdf_link;
		}	


		echo json_encode($this->return); 
	}
	/******************************* View Salary Slip End ***********************************/



}	