<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class MY_Controller extends CI_Controller {

	public $data = array();

	protected $return = array();

    public $ctrl;
    public $method;


	public function __construct(){
		parent::__construct();

		date_default_timezone_set("Asia/Kolkata");

		$this->_common_settings();


        $this->ctrl   = strtolower(str_replace('-', '_', $this->uri->segment(1)));
        $this->method = strtolower(str_replace('-', '_', $this->uri->segment(2)));

        $this->data['ctrl']   = $this->ctrl;
        $this->data['method'] = $this->method;

		$this->_check_session();

		$this->_is_login();

	}




	/******************* Common Settings Start **************************/
	private function _common_settings(){

		if (in_array(date('m'), ["01","02","03"])) {
			$year = date('Y');
		}
		else{
			$year = date('Y')+1;
		}

		$end_date = "31-03-".$year;

		$this->data["end_date"] = $end_date;

		$settings_keys = [
			               'title_bar_name', 'logo_transparent', 'logo_transparent_big', 'logo_wide', 
			               'favicon', 'logo_wide_transparent', 'company_name', 'casual_leave_start_date',
			               'planned_leave_start_date', 'logo_icon', 'copyright_text'
		                 ]; 

		$settings_datas = $this->settings_model->get_bulk_settings($settings_keys);


		$all_settings = [];

		if ($settings_datas) {
			foreach ($settings_datas as $i => $row) {
				$all_settings[$row->settings_key] = $row->settings_value;
			}
		}

		$this->data['settings'] = $all_settings;
	}
	/******************* Common Settings End **************************/





	/******************* Check Session Start **************************/
	private function _check_session(){

		if (!in_array($this->ctrl, ['register', 'login', 'workspace', 'xhr', 'debug', 'cron', 'forgot_password', 'reset_password', 
			'terms_and_conditions', 'privacy_policy'])) {

			if ($this->session->userdata('login')===TRUE) {

				$token_value = $this->session->userdata('token_value');

				$this->load->model('user_model');

				if (!$this->user_model->verify_user_token($token_value)) {
					
					if ($this->input->is_ajax_request()) {

						$this->return['success'] = "You are not authorized to access...";
						$this->return['redirect'] = site_url('login');

						$this->return['time'] = 2000;
						echo json_encode($this->return);	 
						exit();
					}
					else{
						return redirect('login');
					}
				}

				
			}
			else{
				if ($this->input->is_ajax_request()) {

					$this->return['success'] = "You are not authorized to access...";
					$this->return['redirect'] = site_url('login');

					$this->return['time'] = 2000;
					echo json_encode($this->return);	 
					exit();
				}
				else{
					return redirect('login');
				}
			}
		}
			
	}
	/******************* Check Session End **************************/





	/******************* is login Start **************************/
	private function _is_login(){

		if (in_array($this->ctrl, ['register', 'login'])) {

			if ($this->session->userdata('login')===TRUE) {

				$token_value = $this->session->userdata('token_value');

				$this->load->model('user_model');

				if ($this->user_model->verify_user_token($token_value)) {
					
					if ($this->input->is_ajax_request()) {

						$this->return['success'] = "You already logged in...";
						$this->return['redirect'] = site_url('login');

						$this->return['time'] = 2000;
						echo json_encode($this->return);	 
						exit();
					}
					else{
						return redirect('dashboard');
					}
				}
			}	
		}	
	}	
	/******************* is login End **************************/




}
