<?php
defined('BASEPATH') OR exit('No direct script access allowed');


class MY_Loader extends CI_Loader {

    private $ci;

    public function __construct(){
        parent::__construct();
        $this->ci = & get_instance();

        $this->current_method = str_replace('_', '-', strtolower($this->ci->uri->segment(2)));
    }




    /****************** Template Start ****************************************/
    public function template($view_page, $param = array()){

        $content  = $this->ci->load->view('admin/inc/header', $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/left_menu', $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/top_nav_menu', $param, TRUE);

        if (!file_exists(realpath(APPPATH . '/views/admin/'.$view_page.'.php'))){

            $content .= $this->ci->load->view('admin/coming_soon' , $param, TRUE);
        }
        else{
            $content .= $this->ci->load->view('admin/'.$view_page , $param, TRUE);
        }  

        $content .= $this->ci->load->view('admin/inc/footer' , $param, TRUE);    
       

        echo $content;
        
    }
    /********************* Template End **********************************/





    /********************* Error 404 Start ************************************/
    public function error_404($param = array(), $return_type=1){
        
        $content  = $this->ci->load->view('admin/inc/header' , $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/left_menu' , $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/top_nav_menu', $param, TRUE);
        $content .= $this->ci->load->view('admin/error_404' , $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/footer' , $param, TRUE); 

        echo $content;
        exit();
    }
   /************************** Error 404 End *********************************/



   /************************** Error 403 Start **********************************/
    public function error_403($param = array(), $return_type=1){
        
        $content  = $this->ci->load->view('admin/inc/header' , $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/left_menu' , $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/top_nav_menu', $param, TRUE);
        $content .= $this->ci->load->view('admin/error_403' , $param, TRUE);
        $content .= $this->ci->load->view('admin/inc/footer' , $param, TRUE);
        
        echo $content;
        exit();
    }
   /*********************** Error 404 End ************************************/



   /************************** Not Active Start **********************************/
    public function not_active($param = array()){
        
        $content  = $this->ci->load->view('admin/not_active', $this->data, TRUE);
        
        echo $content;
        exit();
    }
   /*********************** Not Active End ************************************/



   /************************** In Maintenance Start **********************************/
    public function in_maintenance($param = array()){
        
        $content  = $this->ci->load->view('admin/in_maintenance', $this->data, TRUE);
        
        echo $content;
        exit();
    }
   /*********************** In Maintenance End ************************************/






    /************** Email Template Start **************************************/
    public function email_template($view_page, $param = array(), $return_type=FALSE, $ext='.php'){
        if (!file_exists(realpath(APPPATH . '/views/email/'. $view_page . $ext))){
            return FALSE;
        }
        else{
            $content  = $this->ci->load->view('email/inc/header' , $param, TRUE);
            $content .= $this->ci->load->view('email/'.$view_page , $param, TRUE);
            $content .= $this->ci->load->view('email/inc/footer' , $param, TRUE);

            if ($return_type) {
                echo $content;
            }
            else{
                return $content;
            }
        }
        
    }
    /************ Email Template Start ******************************************/



   
   

}