<?php

if ( ! function_exists('formatDate')) {
	function formatDate($date){
		if (!empty($date) && $date!=NULL && $date!='0000-00-00') {
			return date('M j, Y, g:i a', strtotime($date));
		}	
  		return NULL;
 	}
}

if ( ! function_exists('format_date')) {
	function format_date($date){
		if (!empty($date) && $date!=NULL && $date!='0000-00-00') {
			return date('d M Y', strtotime($date));
		}
  		return NULL;
 	}
}

if ( ! function_exists('db_date_format')) {
	function db_date_format($date){

		 return (!empty($date)) ? date('Y-m-d', strtotime($date)) : NULL;
	}	
}

if ( ! function_exists('web_date_format')) {
	function web_date_format($date){

		 return (!empty($date)) ? date('d-m-Y', strtotime($date)) : NULL;
	}	

}


if ( ! function_exists('year_format')) {
	function year_format($year){

		 return (empty($year) || $year=='0000') ? NULL : $year;
	}	

}	


if ( ! function_exists('seconds_diff')) {
	function seconds_diff($date1, $date2){
  		//date_default_timezone_set("Asia/Kolkata");

  		$date1 = strtotime($date1);
  		$date2 = strtotime($date2);

  		return $seconds_diff = round(abs($date2 - $date1));
 	}
}


if ( ! function_exists('days_diff')) {
	function days_diff($date1, $date2){
  		date_default_timezone_set("Asia/Kolkata");

  		$date1 = strtotime($date1);
  		$date2 = strtotime($date2);

  		$seconds_diff = round($date2 - $date1);

  		$days = round($seconds_diff/86400);

  		return $days<0 ? $days : ($days+1);
 	}
}


if ( ! function_exists('DateTime_Diff')) {
	function DateTime_Diff($occurrence_Date){

	      date_default_timezone_set("Asia/Kolkata");
	      $current_Date    = strtotime(date("Y-m-d H:i:s"));

	      $occurrence_Date = strtotime($occurrence_Date);

	      $datetime_diff = round(abs($current_Date - $occurrence_Date));

	        if ($datetime_diff <= 60) {
	           
	            $time = $datetime_diff." Seconds";
	         }

	         elseif ($datetime_diff > 60 && $datetime_diff <= 3600) {
	           
	            $time = round($datetime_diff/60)." mins";
	         }

	         elseif ($datetime_diff > 3600 && $datetime_diff <= 86400) {
	           
	            $time = round($datetime_diff/3600)." hours";
	         }

	         elseif ($datetime_diff > 86400 && $datetime_diff <= 86400*13) {
	           
	            $time = round($datetime_diff/86400)." days";
	         }

	        elseif ($datetime_diff > 86400*13 && $datetime_diff <= 86400*31) {
	           
	            $time = round($datetime_diff/(86400*7))." week";
	         }

	        elseif ($datetime_diff > 86400*31 && $datetime_diff <= 86400*365) {
	           
	            $time = round($datetime_diff/(86400*30))." month";
	         }

	        elseif ($datetime_diff > 86400*365) {
	           
	            $time = round($datetime_diff/(86400*365))." year";
	         }

	         return $time;

	     }
}


function secondsToTime($seconds) {
    $dtF = new \DateTime('@0');
    $dtT = new \DateTime("@$seconds");

    if ($seconds<=86400*30) {
    	return $dtF->diff($dtT)->format('%d days');
    }
    elseif ($seconds>86400*30 && $seconds<=86400*365) {
    	return $dtF->diff($dtT)->format('%m months, %d days');
    }
    else{
    	return $dtF->diff($dtT)->format('%y Years, %m months, %d days');
    }
    
}


if ( ! function_exists('month_name')) {
	function month_name($month_no){
		$dateObj   = DateTime::createFromFormat('!m', $month_no);
		return $dateObj->format('F');
	}
}	


if ( ! function_exists('work_exp')) {
	function work_exp($join_month_year, $last_month_year){
		sscanf($join_month_year, '%[^-]-%[^-]', $join_month, $join_year);
		sscanf($last_month_year, '%[^-]-%[^-]', $last_month, $last_year);

		$year_diff  = abs($last_year-$join_year);
		$month_diff = $last_month-$join_month;

		if ($month_diff<0) {
			$year_diff  = $year_diff-1;
			$month_diff = $month_diff+12;
		}

		if ($year_diff==0) {
			$year_str = NULL;
		}
		elseif ($year_diff==1) {
			$year_str = $year_diff.' year - ';
		}
		else{
			$year_str = $year_diff.' years - ';
		}


		if ($month_diff==1 || $month_diff==0) {
			$month_str = '1 month';
		}
		else{
			$month_str = $month_diff.' months';
		}

		return $year_str.$month_str; 
	}
}	


if(!function_exists('month_calculator')){
	function month_calculator($join_month_year, $last_month_year){
		sscanf($join_month_year, '%[^-]-%[^-]', $join_month, $join_year);
		sscanf($last_month_year, '%[^-]-%[^-]', $last_month, $last_year);

		$year_diff  = abs($last_year-$join_year);
		$month_diff = $last_month-$join_month;


		if ($month_diff<0) {
			$year_diff  = $year_diff-1;
			$month_diff = $month_diff+12;
		}

		if ($year_diff>=1) {
			$month_diff = $year_diff*12+$month_diff;
		}

		return $month_diff; 
	}
}


if ( ! function_exists('work_exp_sum')) {
	function work_exp_sum($month_diff){
		$year_diff = 0;
		if($month_diff>=12){
			$year_diff 	= intdiv($month_diff, 12);
			$month_diff = $month_diff % 12;
		}

		if ($year_diff==0) {
			$year_str = NULL;
		}
		elseif ($year_diff==1) {
			$year_str = $year_diff.' year - ';
		}
		else{
			$year_str = $year_diff.' years - ';
		}

		if($month_diff==0){
			$month_str = NULL;
		}
		else if ($month_diff==1) {
			$month_str = '1 month';
		}
		else{
			$month_str = $month_diff.' months';
		}

		return $year_str.$month_str;
	}	
		
}	


