<?php
defined('BASEPATH') OR exit('No direct script access allowed');



if ( ! function_exists('user_img')) {

	function user_img($user_image, $user_gender){

		if (is_file($user_image) && file_exists($user_image)) {
			return base_url($user_image);
		}
		elseif ($user_gender=='male') {
			return base_url('assets/images/male-avatar.png');
		}
		elseif ($user_gender=='female') {
			return base_url('assets/images/female-avatar.png');
		}
		else{
			return base_url('assets/images/demo_user.png');
		}

	}	

}


if ( ! function_exists('format_no')) {

	function format_no($number){

		 $ends = array('th','st','nd','rd','th','th','th','th','th','th');
	    if ((($number % 100) >= 11) && (($number%100) <= 13))
	        return $number. 'th';
	    else
	        return $number. $ends[$number % 10];
	}	
}	



if ( ! function_exists('leave_max_limit')) {

	function leave_max_limit($month){

		$leave_max_limit = [
							 '4'  => 2,
							 '5'  => 4,
							 '6'  => 6,
							 '7'  => 8,
							 '8'  => 10,
							 '9'  => 12,
							 '10' => 14,
							 '11' => 16,
							 '12' => 18,
							 '1'  => 20,
							 '2'  => 22,
							 '3'  => 24  	
		                   ];

        return isset($leave_max_limit[$month]) ? $leave_max_limit[$month] : 0;
	}

}	



if ( ! function_exists('check_access')) {

	function check_access($ctrl){

		$ci =& get_instance();

		$default_ctrl_access   = explode(',', DEFAULT_CTRL_ACCESS);

		$client_ctrl_not_access = explode(',', CLIENT_CTRL_NOT_ACCESS);

        $developer_ctrl_access = explode(',', DEVELOPER_CTRL_ACCESS);

		if ($ci->session->userdata('login')===TRUE && !in_array($ctrl, $default_ctrl_access)) {

			$utype_access_array = explode(',', $ci->session->userdata('user_type_access'));

			if ($ci->session->userdata('login_access_type')=='client' && 
				in_array($ctrl, $client_ctrl_not_access)) {
				
				return FALSE;
			}
			elseif ($ci->session->userdata('user_type_access')=='#' && 
				    in_array($ctrl, $developer_ctrl_access)){
				
				return FALSE;
			}
			elseif (!in_array($ci->session->userdata('user_type_access'), ['*', '#']) && 
				    !in_array($ctrl, $utype_access_array)){

				return FALSE;
			}
		}	

		return TRUE;
	}
}	

if ( ! function_exists('image_upload_option')) {

	function image_upload_option($upload_dir=NULL){
		$upload_dir = $upload_dir ? $upload_dir : "assets/images/upload/";

		$config =  [
				     'upload_path'      => $upload_dir,
				     'allowed_types'    => 'jpg|jpeg|png',
				     'max_size'         => 1024*3,
				     'file_ext_tolower' => TRUE,
					 'encrypt_name'     => TRUE,
					 'overwrite'        => FALSE
	               ];

	    return $config;
	}

}



if ( ! function_exists('url_encode')) {

	function url_encode($str){
		$ci =& get_instance();

		$ci->load->helper('encrypt');

		$enc_str = aes128Encrypt($str, WEB_ENC_KEY);

		return str_replace(array('+', '/', '='), array('-', '_', '~'), $enc_str);
	}

}	


if ( ! function_exists('url_decode')) {

	function url_decode($enc_str){
		$ci =& get_instance();

		$ci->load->helper('encrypt');

		$enc_str = str_replace(array('-', '_', '~'), array('+', '/', '='), $enc_str);

		$enc_str = aes128Decrypt($enc_str, WEB_ENC_KEY);

		return $enc_str;
	}

}	

if(!function_exists('project_status')){
    function project_status($status,$is_badge = FALSE){
        $mode = NULL;
        if($status==0){
            $mode = $is_badge?'<span class="badge badge-warning text-center">Open</span>':'Open';
        }else if($status==1){
            $mode = $is_badge?'<span class="badge badge-success text-center">Completed</span>':'Completed';
        }else if($status==2){
            $mode = $is_badge?'<span class="badge badge-danger text-center">Cancelled</span>':'Cancelled';
        }
        return $mode;
    }
}


if(!function_exists('delete_dir')){
	function delete_dir($dir_path){
		

	    if (is_dir($dir_path)) {
	    	if (substr($dir_path, strlen($dir_path) - 1, 1) != '/') {
		        $dir_path .= '/';
		    }
	    	$files = glob($dir_path . '*', GLOB_MARK);

		    foreach ($files as $file) {
		        if (is_dir($file)) {
		            delete_dir($file);
		        } else {

		        	if (is_file($file) && file_exists($file)) {

		        		exec('sudo chmod ' .$file.' 777');
		        		unlink($file);
		        	}
		            
		        }
		    }

		    rmdir($dir_path);
	    }

	}
}


if(!function_exists('mac_address')){
	function mac_address(){
		ob_start();
    	system('getmac');
    	$content = ob_get_contents();
    	ob_clean();
    	return substr($content, strpos($content,'\\')-20, 17);
	}	
}

if(!function_exists('skills_by_ids')){
	function skills_by_ids($skill_ids){
	    $ci = & get_instance();

	    $skill_id_array = explode(',', $skill_ids);  
	    $skill_name_array = array();
	    foreach ($skill_id_array as $each_id) {
	        if ($skill_data = $ci->db->get_where('skills', ['_skill_id' => $each_id])->row()) {
	            array_push($skill_name_array ,$skill_data->skill_name);
	        }
	    } 

	    if ($skill_name_array) {
	        return implode(',', $skill_name_array);
	    }
	}
}