<?php
defined('BASEPATH') OR exit('No direct script access allowed');


if ( ! function_exists('flash_redirect')){
	function flash_redirect($is_success, $successMsg, $failureMsg, $redirect=NULL){
		$ci = & get_instance();
	    if ( $is_success ) {
			$ci->session->set_flashdata('feedback', $successMsg);
			$ci->session->set_flashdata('feedback_class', 'alert-success');
		}
		else{
			$ci->session->set_flashdata('feedback', $failureMsg);
			$ci->session->set_flashdata('feedback_class', 'alert-danger');
		}

		if ($redirect) {
			return redirect($redirect);
		}
		else{
			return false;
		}
	}

}


if ( ! function_exists('flash_msg')){
	
	function flash_msg($feedback){
		$ci = & get_instance();
		$feedback_class = $ci->session->flashdata('feedback_class');

		$html = "<br>
				<div class='alert alert-dismissible  $feedback_class'>
				<button type='button' class='close' data-dismiss='alert'>x</button>
				<strong>$feedback</strong>
				</div>";

		if ($feedback) {
			 return $html;
		} 
	}

}


if ( ! function_exists('no_data')){
	
	function no_data($msg=NULL){
		$ci = & get_instance();

		$html = "<div class='panel panel-danger'>
                  <div class='panel-heading'>".$msg."</div>
                </div>";

		if ($msg) {
			 return $html;
		} 
	}

}




if ( ! function_exists('alert_msg')){
	
	function alert_msg($is_true, $msg){
		$ci = & get_instance();
		if ($is_true==TRUE) {
			$class = 'alert-success';
			//$symbol = '&#x2705';
		}
		else{
			$class = 'alert-danger';
			//$symbol = '&#10006';
		}
		
		if ($msg!='') {
			$print = "<br>
					<div class='alert alert-dismissible  $class'>
					<button type='button' class='close' data-dismiss='alert'>x</button>
					 $msg
					</div>";
		}
		else{
			$print = '';
		}	
		return $print;
			
	}

}	


if ( ! function_exists('error_msg')){

	function error_msg($msg){

		echo "<p style='color:red'>".$msg."</p>";

	}

}	