<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class MY_Form_validation extends CI_Form_validation {

    private $ci;

    public function __construct($rules = array()){
        parent::__construct($rules);

        $this->ci = & get_instance();

        $this->set_error_delimiters("<span style='color:red'>", "</span>");

        $this->custom_messages();
    }

    public function sanitize ($string){
        return textile_sanitize($string);
    }


    function valid_url($str){

           $pattern = "/^(http|https|ftp):\/\/([A-Z0-9][A-Z0-9_-]*(?:\.[A-Z0-9][A-Z0-9_-]*)+):?(\d+)?\/?/i";
            if (!preg_match($pattern, $str))
            {
                return FALSE;
            }

            return TRUE;
    }


    public function get_data($str, $key){

        if (isset($this->_field_data[$key]) && isset($this->_field_data[$key]['postdata'])) {
            return $this->_field_data[$key]['postdata'];
        }
    }


    public function set_data(array $data){
        if ( ! empty($data)){
            $this->validation_data = $data;
        }

        global $fm_data;

        $fm_data = $this;

        return $this;
    }


    /******************************** Is Unique start *****************************************/
    public function is_unique($str, $field){

        $db = $this->ci->db;

        sscanf($field, '%[^.].%[^.]', $table, $field);

        return isset($db)
            ? ($db->limit(1)->get_where($table, array($field => $str))->num_rows() === 0)
            : FALSE;
    }
    /******************************** Is Unique end *****************************************/

    


    /******************************** Is Unique Where start *****************************************/
    public function is_unique_where($str, $param){

        $db = $this->ci->db;

        if (!empty($str)) {

            if (isset($param)) {
                if (substr_count($param, '.') == 2) {
                    sscanf($param, '%[^.].%[^.].%[^.]', $table, $field, $where);

                    if ($db->table_exists($table)) {

                        if ($db->field_exists($field, $table)) {

                            $row_count = $db->limit(1)
                                            ->from($table)
                                            ->where($field, $str)
                                            ->where($where, NULL, FALSE)
                                            ->count_all_results();


                            if ($row_count === 0) {
                                return TRUE;
                            }
                            else{
                                $this->set_message('is_unique_where', lang('is_unique'));
                                return FALSE;
                            }                          
                        }  
                        else{
                            $this->set_message('is_unique_where', $field.'field is not exist in table name '.$table);
                            return FALSE;
                        }  
                    }  
                    else{
                        $this->set_message('is_unique_where', $table.' table is not exist');
                        return FALSE;
                    }   
                }
                else{
                    $this->set_message('is_unique_where', 'Second Parameter value is not given in proper format in {field} validation');
                    return FALSE;
                }    
            } 
            else{
                $this->set_message('is_unique_where', 'Second Parameter is not given in {field} validation');
                return FALSE;
            }   
        }    

        return TRUE; 
    }
    /***************************************** Is Unique Where End ************************************************/



    /***************************************** Edit Unique Where start ************************************************/
   public function edit_unique_where($str, $param){

        $db = $this->ci->db;

        if (!empty($str)) {

            if (isset($param)) {

                if (substr_count($param, '.') == 4) {
                    sscanf($param, '%[^.].%[^.].%[^.].%[^.].%[^.]', $table, $field, $primary_key, $primary_key_val, $where);

                    if ($db->table_exists($table)) {

                        if ($db->field_exists($field, $table) && $db->field_exists($primary_key, $table)) {

                            $row_count = $db->limit(1)
                                            ->from($table)
                                            ->where($field, $str)
                                            ->where($primary_key . ' != ', $primary_key_val, NULL, FALSE)
                                            ->where($where, NULL, FALSE)
                                            ->count_all_results();


                            if ($row_count === 0) {
                                return TRUE;
                            }
                            else{
                                $this->set_message('edit_unique_where', lang('is_unique'));
                                return FALSE;
                            } 
                        }  
                        else{
                            $this->set_message('edit_unique_where', $field.'field is not exist in table name '.$table);
                            return FALSE;
                        }  

                    }  
                    else{
                        $this->set_message('edit_unique_where', $table.' table is not exist');
                        return FALSE;
                    }  
                }
                else{
                    $this->set_message('edit_unique_where', 'Second Parameter value is not given in proper format in {field} validation');
                    return FALSE;
                }     
            } 
            else{
                $this->set_message('edit_unique_where', 'Second Parameter is not given in {field} validation');
                return FALSE;
            }   
        }
        
        return TRUE;    
    }
    /***************************************** Edit Unique Where End ************************************************/




    /***************************************** Edit Unique start ****************************************************/
    public function edit_unique($str, $param){

        $db = $this->ci->db;

        if (!empty($str)) {

            if (isset($param)) {
                if (substr_count($param, '.') == 3) {
                    sscanf($param, '%[^.].%[^.].%[^.].%[^.]', $table, $field, $primary_key, $primary_key_val);

                    if ($db->table_exists($table)) {
                        if ($db->field_exists($field, $table) && $db->field_exists($primary_key, $table)) {
                            
                            $row_count = $db->limit(1)
                                            ->from($table)
                                            ->where($field, $str)
                                            ->where($primary_key . ' != ', $primary_key_val, NULL, FALSE)
                                            ->count_all_results();


                            if ($row_count === 0) {
                                return TRUE;
                            }
                            else{
                                $this->set_message('edit_unique', lang('is_unique'));
                                return FALSE;
                            }                  
                        }   
                        else{
                            $this->set_message('edit_unique', $field.'field is not exist in table name '.$table);
                            return FALSE;
                        } 

                    }
                    else{
                        $this->set_message('edit_unique', $table.' table is not exist');
                        return FALSE;
                    }    


                }
                else{
                    $this->set_message('edit_unique', 'Second Parameter value is not given in proper format in {field} validation');
                    return FALSE;
                }
            }
            else{
                $this->set_message('edit_unique', 'Second Parameter is not given in {field} validation');
                return FALSE;
            }
        } 
        
        return TRUE;  
    }    
    /***************************************** Edit Unique end ****************************************************/



   



    /*********************************** Check the value exist in a table or not start *****************************/
    public function check_val_exist($str, $param){

        $db = $this->ci->db;

        sscanf($param, '%[^.].%[^.]', $table, $column_name);

        if (!empty($str)) {
            if (is_array($str)) {
                $this->set_message('check_val_exist', lang('check_val_exist'));
                    return FALSE;
            }
            else{
                $row_count = $db->from($table)->where($column_name, $str)->count_all_results();

                if ($row_count==0) {
                    $this->set_message('check_val_exist', lang('check_val_exist'));
                    return FALSE;
                }

                return TRUE;
            }
            
        }

        return TRUE;
    }
   /*********************************** Check the value exist in a table or not end ********************************/



    /*********************************** Check the value exist with where cond in a table or not start *****************************/
    public function check_val_exist_where($str, $param){

        $db = $this->ci->db;

        if (!empty($str)) {

            if (isset($param)) {
                if (substr_count($param, '.') == 2) {
                    sscanf($param, '%[^.].%[^.].%[^.]', $table, $field, $where);

                    if ($db->table_exists($table)) {

                        if ($db->field_exists($field, $table)) {

                            $row_count = $db->limit(1)
                                            ->from($table)
                                            ->where($field, $str)
                                            ->where($where, NULL, FALSE)
                                            ->count_all_results();


                            if ($row_count === 0) {
                                $this->set_message('check_val_exist_where', lang('check_val_exist_where'));
                                return FALSE;
                            }
                            else{
                                return TRUE;
                            }                          
                        }
                        else{
                            $this->set_message('check_val_exist_where', $field.'field is not exist in table name '.$table);
                            return FALSE;
                        }    

                    }
                    else{
                        $this->set_message('check_val_exist_where', $table.' table is not exist');
                        return FALSE;
                    }     

                }
                else{
                    $this
                    ->set_message('check_val_exist_where', 'Second Parameter value is not given in proper format in {field} validation');
                    return FALSE;
                }    

            }
            else{
                $this->set_message('check_val_exist_where', 'Second Parameter is not given in {field} validation');
                return FALSE;
            }    
        } 
        
        return TRUE;   
    }    
    /*********************************** Check the value exist with where cond in a table or not start *****************************/





    /*********************************** Check only numeric with no leading zero start *****************************/
    public function check_numeric($str){
        if (preg_match("/^[1-9][0-9]*$/", $str) || empty($str)) {
              return TRUE;          
        }
        else{
            $this->set_message('check_numeric', lang('check_numeric'));
            return FALSE;
        }
    }
    /********************************** Check only numeric with no leading zero end **********************************/




    /*********************************** Check only numeric with leading zero start ********************************/
    public function check_numeric_allowed_leading_zero($str){
        if (preg_match("/^[0-9]*$/", $str)) {
              return TRUE;          
        }
        else{
            $this->set_message('check_numeric', lang('check_numeric_allowed_leading_zero'));
            return FALSE;
        }
    }
    /*********************************** Check only numeric with leading zero end ************************************/




    /******* Check password combination [Min 8 chars with min 1 Capital alphabet & min 1 special char] start **************/
    public function password_check($password){
        if ($password!='') {
            
            if (preg_match("/(?=^.{8,}$)(?=.*[~!@#$%^&*()_]+)(?![.\\n])(?=.*[A-Z]).*$/", $password)) {
              return TRUE;          
            }
            else{
                $this->set_message('password_check', lang('password_check'));
                return FALSE;
            }
        }
          
        return TRUE;
    }
    /******* Check password combination [Min 8 chars with min 1 Capital alphabet & min 1 special char] end ****************/




    

    /********************************** Override Codeignitor validation message start ****************************************/
    private function custom_messages(){
        $this->set_message('valid_email', lang('valid_email'));
        $this->set_message('required', lang('required'));
        $this->set_message('is_unique', lang('is_unique'));
    }
   /********************************** Override Codeignitor validation message end ***********************************/





   /****************************************check_date start ********************************************/
   //Date Format DD-MM-YYYY
    public function check_date($date){
        if ($date!='') {
            $date_array = explode("-", $date);
            if (count($date_array)==3) {
                $day    = $date_array[0];
                $month  = $date_array[1];
                $year   = $date_array[2];

                if ( is_numeric($day)   && is_numeric($month)  && is_numeric($year) && 
                     strlen($day) == 2  && strlen($month) == 2  && strlen($year) == 4) {
                    
                    if (!checkdate($month, $day, $year)) {
                        $this->set_message('check_date', '{field} is invalid ');
                        return FALSE;               
                    }
                    return TRUE;
                }
                $this->set_message('check_date', '{field} is in invalid format');
                return FALSE;    
            }
            $this->set_message('check_date', '{field} format should be in DD-MM-YYYY');
            return FALSE;
        }
        return TRUE;
    }
    /********************************************check_date End *************************************/





    /****************************************** Return False if Future date start ******************************/
    //Return False if Future date
    public function check_future_date($date){
        if ($date!='') {
            if ($this->check_date($date)) {
                    $current_Date    = new DateTime(date("Y-m-d"));
                    $occurrence_Date = new DateTime($date);

                    if ($occurrence_Date > $current_Date) {
                        $this->set_message('check_future_date', 'Future Date is not allowed in {field} ');
                        return FALSE;
                    }
                    return TRUE;
            }
            $this->set_message('check_future_date', '{field} Date format should be in DD-MM-YYYY');
            return FALSE;
        }
        return TRUE;
    }
    /****************************************** Return False if Future date end ****************************/







    /*************************************** Return False if Previous date start *******************************/
    public function check_previous_date($date){
        if ($date!='') {
            if ($this->check_date($date)) {
                    $current_Date    = new DateTime(date("Y-m-d"));
                    $occurrence_Date = new DateTime($date);

                    if ($occurrence_Date < $current_Date) {
                        $this->set_message('check_previous_date', 'Back Date is not allowed in {field} ');
                        return FALSE;
                    }
                    return TRUE;
            }
            $this->set_message('check_previous_date', '{field} Date format should be in DD-MM-YYYY');
            return FALSE;
        }
        return TRUE;
    }
    /********************************** Return False if Previous date end ********************************/






    /********************************** Return False if Future year start *********************************/
    //Return False if Future year
    public function check_future_year($year){
        if ($year!='') {
            if (is_numeric($year) && strlen($year)==4) {
                if ($year > date('Y')) {
                    $this->set_message('check_future_year', 'Future year is not allowed in {field}');
                    return FALSE;
                }
                return TRUE;
            }
            $this->set_message('check_future_year', 'Invalid Year given in {field}');
            return FALSE;
        }
        return TRUE;
    }
    /************************************ Return False if Future year end *********************************/





    /*********************************** check valid year start ******************************************/
    public function check_valid_year($year){
        if (!empty($year)) {
            $start_year    =   strtotime(date('Y') - 100); //100 Years back
            $end_year      =   strtotime(date('Y') + 100); // Current Year
            $received_year =   strtotime($year);

            if (($received_year >= $start_year) && ($received_year <= $end_year)) {
                return TRUE;
            }
            else{
                $this->set_message('check_valid_year', 'Invalid Year given in {field}');
                return FALSE;
            }
        }
        return TRUE;
    }
    /************************************** check valid year end ******************************************/






    /********************************** validate required age from dob start *******************************/
    public function validate_age_from_dob($str, $required_age){
        if (!empty($str)) {
            date_default_timezone_set("Asia/Kolkata");

            $current_date    = strtotime(date("d-m-Y"));

            $dob_Date = strtotime($str);

            $datetime_diff = round(abs($current_date - $dob_Date));

            $date_diff_year = $datetime_diff/(86400*365);

            if ($date_diff_year < $required_age) {

                $this->set_message('validate_age_from_dob', 'Min required age is '.$required_age.' in {field}');
                return FALSE;
            } 
            return TRUE;    
        } 
        return TRUE;   
    }
    /************************************** validate required age from dob end **********************************/






    /************************************** check two field having same value start ******************************/
    public function same_value($str ,$field){
        $field_val = $this->ci->input->post($field);

        if ($str && $field_val) {
            if ($str == $field_val) {
                $this->set_message('same_value', '{field} cant be same {param}.');
                return FALSE;
            }
        }
        return TRUE;
    }
    /************************************** check two field having same value end *********************************/





    /************************************** valid controller start ***************************************/
    public function valid_controller($str){
        if (!empty($str)) {
            $all_ctrls = array_values(array_diff(scandir(APPPATH.'/controllers'), array('..', '.')));


            for ($i=0; $i < count($all_ctrls); $i++) { 
                $all_ctrls[$i] = str_replace('_', '-', strtolower(preg_replace('/\.[^.]+$/','',$all_ctrls[$i])));
            }

            if (in_array($str, $all_ctrls)) {
                $this->set_message('valid_controller', 'This {field} is not available');
                return FALSE;
            }

        
        }
        return TRUE;
    }
    /************************************** valid controller end ******************************************/




    /************************************** valid slug start ***************************************/
    public function valid_slug($str){
        if (!empty($str)) {
            if (preg_match("/^[a-z]+(?:-[a-z]+)*$/", $str)) {
                return TRUE;
            }    
            $this->set_message('valid_slug', 'Only small letter and dash allowed. Leading dash, trailing dash and consecutive dash not allowed.');
            return FALSE;
        }
        
        return TRUE;    
    }
    /************************************** valid slug start ***************************************/




    /************************************** Check Mobile & Email start *********************************/
    public function check_mobile_n_email($str){
        if (!empty($str)) {
            if (preg_match("/^[1-9][0-9]*$/", $str) && strlen($str)==10) {
                return TRUE;
            }
            elseif (filter_var($str, FILTER_VALIDATE_EMAIL)) {
                return TRUE;
            }

            $this->set_message('check_mobile_n_email', 'Enter valid Email or Mobile.');
            return FALSE; 
        }    
        
        return TRUE;    
    }
    /************************************** Check Mobile & Email End *********************************/




    /************************************** Check DB Password start *********************************/
    public function check_db_password($password, $enc_pass){
        if (!empty($password)) {

            $this->ci->load->library('password_hash');

            $pass_check = FALSE;    

            try{
                $pass_check = $this->ci->password_hash->check_pass($enc_pass, $password);
            }
            catch(Exception $e) { 
                //echo $e;
            }
            
            if ($pass_check) {
               return TRUE;

            }
            else{
                $this->set_message('check_db_password', '{field} Not Matched');
                return FALSE;
            }
        }

        return TRUE; 
    }
    /************************************** Check DB Password End *********************************/




    /************************************** Valid Month & Year Start *******************************/
    public function month_year($str){
        if (!empty($str)) {
            $date = '01-'.$str;

            sscanf($date, '%[^-]-%[^-]-%[^-]', $day, $month, $year);

            if (is_numeric($month)  && is_numeric($year) && strlen($month) == 2  && strlen($year) == 4) {
                    if (!checkdate($month, $day, $year)) {
                        $this->set_message('month_year', '{field} Date is invalid ');
                        return FALSE;               
                    }
                    return TRUE;
            }

            $this->set_message('month_year', '{field} date is in invalid format');
            return FALSE;  
        } 
         return TRUE;      
    }
    /************************************** Valid Month & Year End *********************************/



    /************************************** Validate Last Date Start *******************************/
    public function validate_last_date($last_month_year, $join_month_year){
        if (!$last_month_year || !$join_month_year) {
           return TRUE;
        }
        else{
            $join_date = new DateTime('01-'.$join_month_year);
            $last_date = new DateTime('01-'.$last_month_year);

            if ($last_date < $join_date) {
                $this->set_message('validate_last_date', '{field} cant be before Join Date');
                return FALSE;
            }
            return TRUE;
        }

        
    }
    /************************************** Validate Last Date End *******************************/

     



    /************************************** Slug Start *******************************/
     public function slug($str){
        return trim(strtolower(preg_replace('/[^A-Za-z0-9-]+/', '-', $str)), '-');
     }
    /************************************** Slug End *******************************/





    /************************************** Valid Base64 Image Start *******************************/
    public function valid_base64_image($str){
        if (!empty($str)) {
            $img = @imagecreatefromstring(base64_decode($str));

            if ($img === FALSE) {
                $this->set_message('valid_base64_image', lang('valid_base64_image'));
                return FALSE;
            }

            return TRUE;
        }

        return TRUE;
    }
    /************************************** Valid Base64 Image End *******************************/




    /************************************** Comma Seperated ID Start *******************************/
    public function comma_seperated_id($str){
        if (!empty($str)) {
            if ( preg_match("/^\d+(?:,\d+)*$/", $str) ){
                return TRUE;
            }

            $this->set_message('comma_seperated_id', lang('comma_seperated_id'));
            return FALSE;   
        }

        return TRUE;
    }
    /************************************** Comma Seperated ID End *******************************/





 
    /**************************************Validate Latitude Start *******************************/
    public function validate_latitude($str){
        if (!empty($str)) {

            if (!preg_match('/^(\+|-)?(?:90(?:(?:\.0{1,6})?)|(?:[0-9]|[1-8][0-9])(?:(?:\.[0-9]{1,20})?))$/', $str)) {

                $this->set_message('validate_latitude', "Invalid latitude given");
                return FALSE; 
            }
        } 
        
        return TRUE;   
    }
    /**************************************Validate Latitude End *******************************/



    /**************************************Validate Longitude Start *******************************/
    public function validate_longitude($str){
        if (!empty($str)) {

            if (!preg_match('/^(\+|-)?(?:180(?:(?:\.0{1,6})?)|(?:[0-9]|[1-9][0-9]|1[0-7][0-9])(?:(?:\.[0-9]{1,20})?))$/', $str)) {

                $this->set_message('validate_longitude', "Invalid longitude given");
                return FALSE; 
            }
        } 
        
        return TRUE; 
    }
    /**************************************Validate Longitude End *******************************/


    /**************************************Validate GPS Start *******************************/
    public function validate_gps($str){

        sscanf($str, '%[^,],%[^,]', $lat, $lon);

        if (!empty($str)) {

            if (!preg_match('/^(\+|-)?(?:90(?:(?:\.0{1,6})?)|(?:[0-9]|[1-8][0-9])(?:(?:\.[0-9]{1,20})?))$/', $lat)) {

                $this->set_message('validate_gps', "Invalid latitude given");
                return FALSE; 
            }
            elseif (!preg_match('/^(\+|-)?(?:180(?:(?:\.0{1,6})?)|(?:[0-9]|[1-9][0-9]|1[0-7][0-9])(?:(?:\.[0-9]{1,20})?))$/', $lon)) {

                $this->set_message('validate_gps', "Invalid longitude given");
                return FALSE; 
            }
            
        } 
        
        return TRUE;    
    }
    /**************************************Validate GPS End *******************************/


}