<?php
defined('BASEPATH') OR exit('No direct script access allowed');


/**
* App Form Validation Rules for Admin Library
*/
class Admin_rules{


	private $ci;

	public function __construct(){
        // Assign the CodeIgniter super-object
        $this->ci =& get_instance();
    }




    public function login(){
    	$rules = [
					[
						'field' => 'user_email',
						'label' => 'Email',
						'rules' => 'required|trim|htmlspecialchars|valid_email'
					],

					[
						'field' => 'user_password',
						'label' => 'Password',
						'rules' => 'required'
					]
    	         ];

    	return $rules;        
    }



    public function update_my_password($enc_pass){
    	$rules = [

    				[
						'field' => 'current_password',
						'label' => 'Current Password',
						'rules' => 'required|check_db_password['.$enc_pass.']'
					],

					[
						'field' => 'new_password',
						'label' => 'New Password',
						'rules' => 'required|password_check|differs[current_password]'
					],

					[
						'field' => 'confirm_password',
						'label' => 'Confirm Password',
						'rules' => 'required|matches[new_password]'
					]

    		     ];


    	return $rules;	
    }




    public function add_note(){
    	$rules = [
					[
						'field' => 'unote_title',
						'label' => 'Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'unote_desc',
						'label' => 'Description',
						'rules' => 'required|trim|htmlspecialchars'
					]
    	         ];

    	return $rules;        
    }



    public function update_general_info($_user_id){

    	$rules = [
					[
						'field' => 'user_first_name',
						'label' => 'First Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_last_name',
						'label' => 'Last Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_dob',
						'label' => 'DOB',
						'rules' => 'required|trim|htmlspecialchars|check_date|check_future_date|validate_age_from_dob[15]'
					],

					[
						'field' => 'user_gender',
						'label' => 'Gender',
						'rules' => 'required|trim|htmlspecialchars|in_list[male,female,other]'
					],

					[
						'field' => 'user_email',
						'label' => 'Email',
						'rules' => 'required|trim|htmlspecialchars|edit_unique[users.user_email._user_id.'.$_user_id.']'
					],

					[
						'field' => 'user_mobile',
						'label' => 'Mobile',
						'rules' => 'required|trim|htmlspecialchars|check_numeric|exact_length[10]|edit_unique[users.user_mobile._user_id.'.$_user_id.']'
					],

					[
						'field' => 'user_alternate_phone',
						'label' => 'Alternate Mobile',
						'rules' => 'trim|htmlspecialchars|check_numeric|exact_length[10]|differs[user_mobile]'
					],

					[
						'field' => 'user_address',
						'label' => 'Address',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_alternate_address',
						'label' => 'Current Address',
						'rules' => 'trim|htmlspecialchars|differs[user_address]'
					]


    	         ];

    	return $rules;   
    }	



    public function update_job_info($_user_id){

    	$rules = [
					[
						'field' => 'user_job_title',
						'label' => 'JOB Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_hourly_cost',
						'label' => 'Hourly Cost',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'user_yearly_leave',
						'label' => 'Yearly Leave',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'user_skills[]',
						'label' => 'Skills',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_date_of_joining',
						'label' => 'Date of Joining',
						'rules' => 'required|trim|htmlspecialchars|check_date'
					],

					[
						'field' => 'user_emp_code',
						'label' => 'Employee Code',
						'rules' => 'required|trim|htmlspecialchars|edit_unique[users.user_emp_code._user_id.'.$_user_id.']'
					],

					[
						'field' => 'user_pan',
						'label' => 'PAN',
						'rules' => 'trim|htmlspecialchars|edit_unique[users.user_pan._user_id.'.$_user_id.']'
					]


    	         ];

    	return $rules;   

    }	


    public function update_bank_details($_user_id){

    	$rules = [
					[
						'field' => 'bank_account_no',
						'label' => 'Account No',
						'rules' => 'required|trim|htmlspecialchars|edit_unique[user_bank_details.bank_account_no.bank_user_id.'.$_user_id.']'
					],

					[
						'field' => 'bank_name',
						'label' => 'Bank Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'bank_branch_name',
						'label' => 'Branch Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'bank_ifsc_code',
						'label' => 'IFSC Code',
						'rules' => 'required|trim|htmlspecialchars'
					]
    	         ];

    	return $rules;   
    }	


    public function update_salary_details(){
    	$rules = [
					[
						'field' => 'salary_total',
						'label' => 'Salary Per Month',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_basic',
						'label' => 'Basic Salary',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_hra',
						'label' => 'HRA',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_conveyance_allowance',
						'label' => 'Conveyance Allowance',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],


					[
						'field' => 'salary_special_allowance',
						'label' => 'Special Allowance',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_work_from_home',
						'label' => 'Work From Home',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_esic_employee',
						'label' => 'ESIC Contribution by Employee',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_esic_employer',
						'label' => 'ESIC Paid by Employer',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_pf_employee',
						'label' => 'PF Contribution by Employee',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_pf_employer',
						'label' => 'PF Paid by Employer',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_professional_tax',
						'label' => 'Professional Tax',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_tds',
						'label' => 'TDS',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					]
    	         ];

    	return $rules;        
    }



    public function apply_leave($post_data){

    	$rules = [
					[
						'field' => 'leave_type',
						'label' => 'Leave Type',
						'rules' => 'required|trim|htmlspecialchars|in_list[casual,planned]'
					],

					[
						'field' => 'leave_duration',
						'label' => 'Duration',
						'rules' => 'required|trim|htmlspecialchars|in_list[half,single,multiple]'
					],

					[
						'field' => 'leave_reason',
						'label' => 'Reason',
						'rules' => 'required|trim|htmlspecialchars'
					]

				 ];	

        $which_half = [
						'field' => 'leave_half_day',
						'label' => 'Which Half',
						'rules' => 'required|trim|htmlspecialchars|in_list[1,2]'
					  ];


		$leave_date = [
						'field' => 'leave_date',
						'label' => 'Date',
						'rules' => 'required|trim|htmlspecialchars|check_date|check_previous_date'
					  ];


		$leave_start_date = [
								'field' => 'leave_start_date',
								'label' => 'Start Date',
								'rules' => 'required|trim|htmlspecialchars|check_date|check_previous_date'
						    ];


		$leave_end_date = [
							'field' => 'leave_end_date',
							'label' => 'End Date',
							'rules' => 'required|trim|htmlspecialchars|check_date|check_previous_date'
						  ];				    				  			  


		if (isset($post_data['leave_duration']) && $post_data['leave_duration']=="half") {
			array_push($rules, $which_half);
		}

		if (isset($post_data['leave_duration']) && in_array($post_data['leave_duration'], ['half','single'])) {
			array_push($rules, $leave_date);
		}


		if (isset($post_data['leave_type']) && $post_data['leave_type']=="planned" &&
	        isset($post_data['leave_duration']) && $post_data['leave_duration']=="multiple") {

			array_push($rules, $leave_start_date);
		    array_push($rules, $leave_end_date);
		}			  



		return $rules;  		 
    }

    public function add_client(){
    	$rules = [
					[
						'field' => 'client_name',
						'label' => 'Client Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'client_email',
						'label' => 'Email',
						'rules' => 'required|trim|htmlspecialchars|valid_email'
					],

					[
						'field' => 'client_phone',
						'label' => 'Phone',
						'rules' => 'trim|htmlspecialchars|check_numeric'
					],

					[
						'field' => 'client_address',
						'label' => 'Address',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'client_pincode',
						'label' => 'Pincode',
						'rules' => 'trim|htmlspecialchars|check_numeric'
					],

					[
						'field' => 'client_city',
						'label' => 'City',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'client_state',
						'label' => 'State',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'client_state_code',
						'label' => 'State Code',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'client_country',
						'label' => 'Country',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'client_website',
						'label' => 'Website',
						'rules' => 'trim|htmlspecialchars|valid_url'
					],

					[
						'field' => 'client_gstin',
						'label' => 'GSTN',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'client_currency',
						'label' => 'Select Currency',
						'rules' => 'required|trim|htmlspecialchars|check_val_exist[currencies._currency_id]'
					],
    	         ];

    	return $rules;
    }

    public function add_client_contact(){

    	$rules =[
					[
						'field' => 'user_first_name',
						'label' => 'First Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_last_name',
						'label' => 'Last Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_email',
						'label' => 'Email',
						'rules' => 'required|trim|htmlspecialchars|valid_email|is_unique[users.user_email]'
					],

					[
						'field' => 'user_mobile',
						'label' => 'Phone',
						'rules' => 'trim|htmlspecialchars|check_numeric'
					],

					[
						'field' => 'user_skype_id',
						'label' => 'Skype',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'user_job_title',
						'label' => 'Job Title',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'user_gender',
						'label' => 'Gender',
						'rules' => 'required|trim|htmlspecialchars|in_list[male,female]'
					],

					[
						'field' => 'user_password',
						'label' => 'Password',
						'rules' => 'required|password_check'
					]
    	        ];

    	return $rules;
    }



    public function add_attendence(){

    	$rules =[
					[
						'field' => 'attendence_user_id',
						'label' => 'Team Member',
						'rules' => 'required|trim|htmlspecialchars|check_val_exist[users._user_id]'
					],

					[
						'field' => 'attendence_date',
						'label' => 'Date',
						'rules' => 'required|trim|htmlspecialchars|check_date|check_future_date'
					],

					[
						'field' => 'attendence_in_time',
						'label' => 'In Time',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'attendence_out_time',
						'label' => 'Out Time',
						'rules' => 'required|trim|htmlspecialchars'
					]


				];

		return $rules;		
    }	




    public function add_monthly_summary(){

    	$rules =[
					[
						'field' => 'attendence_summary_user_id',
						'label' => 'Team Member',
						'rules' => 'required|trim|htmlspecialchars|check_val_exist[users._user_id]'
					],

					[
						'field' => 'attendence_summary_month',
						'label' => 'Month',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'attendence_summary_days_in_month',
						'label' => 'Days in Month',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[28]|less_than_equal_to[31]'
					],

					[
						'field' => 'attendence_summary_days_present',
						'label' => 'Present Count',
						'rules' => 'trim|htmlspecialchars|less_than_equal_to[31]'
					],

					[
						'field' => 'attendence_summary_days_absent',
						'label' => 'Absent Count',
						'rules' => 'trim|htmlspecialchars|less_than_equal_to[31]'
					],

					[
						'field' => 'attendence_summary_leave_taken',
						'label' => 'Leave Count',
						'rules' => 'trim|htmlspecialchars|less_than_equal_to[24]'
					],

					[
						'field' => 'attendence_summary_late_count',
						'label' => 'Late Count',
						'rules' => 'trim|htmlspecialchars|less_than_equal_to[23]'
					]
    	        ];

    	return $rules;
    }	

    public function add_project(){
    	$rules = [
					[
						'field' => 'project_title',
						'label' => 'Project Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'project_client_id',
						'label' => 'Client',
						'rules' => 'required|trim|htmlspecialchars|check_val_exist[clients._client_id]'
					],

					[
						'field' => 'project_description',
						'label' => 'Description',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'project_start_date',
						'label' => 'Start Date',
						'rules' => 'required|trim|check_date'
					],

					[
						'field' => 'project_deadline',
						'label' => 'Deadline',
						'rules' => 'required|trim|check_date'
					],

					[
						'field' => 'project_price',
						'label' => 'Price',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'project_skills[]',
						'label' => 'Skills',
						'rules' => 'required|trim|htmlspecialchars'
					]
    	         ];

    	return $rules;
    }

    public function edit_project(){
    	$rules =[
					[
						'field' => 'project_title',
						'label' => 'Project Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'project_description',
						'label' => 'Description',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'project_start_date',
						'label' => 'Start Date',
						'rules' => 'required|trim|check_date'
					],

					[
						'field' => 'project_deadline',
						'label' => 'Deadline',
						'rules' => 'required|trim|check_date'
					],

					[
						'field' => 'project_price',
						'label' => 'Price',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'project_skills[]',
						'label' => 'Skills',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'project_status',
						'label' => 'Status',
						'rules' => 'required|trim|htmlspecialchars|in_list[0,1,2]'
					]
    	        ];

    	return $rules;
    }

    public function edit_salary_slip($_salary_slip_id){

    	$rules = [
					[
						'field' => 'salary_slip_per_month',
						'label' => 'Salary Per Month',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_basic',
						'label' => 'Basic Salary',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_hra',
						'label' => 'HRA',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_conveyance_allowance',
						'label' => 'Conveyance Allowance',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],


					[
						'field' => 'salary_slip_special_allowance',
						'label' => 'Special Allowance',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_work_from_home',
						'label' => 'Work From Home',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_esic_employee',
						'label' => 'ESIC Contribution by Employee',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_esic_employer',
						'label' => 'ESIC Paid by Employer',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_pf_employee',
						'label' => 'PF Contribution by Employee',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_pf_employer',
						'label' => 'PF Paid by Employer',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_professional_tax',
						'label' => 'Professional Tax',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'salary_slip_tds',
						'label' => 'TDS',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					]
    	         ];

    	return $rules;        
    }

    public function add_milestone(){
    	$rules =[
					[
						'field' => 'milestone_title',
						'label' => 'Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'milestone_description',
						'label' => 'Description',
						'rules' => 'trim|htmlspecialchars'
					],

					[
						'field' => 'milestone_due_date',
						'label' => 'Due Date',
						'rules' => 'required|trim|check_date'
					]
    	        ];

    	return $rules;
    }



    public function update_general_settings(){

    	$rules =[
					[
						'field' => 'title_bar_name',
						'label' => 'Title Bar Text',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'copyright_text',
						'label' => 'Copyright',
						'rules' => 'required|trim|htmlspecialchars'
					]
    	        ];

    	return $rules;
    }



    public function update_company_settings(){

    	$rules = [

    		        [
						'field' => 'company_name',
						'label' => 'Company Name',
						'rules' => 'trim|required|htmlspecialchars'
					],

    		        [
						'field' => 'company_email',
						'label' => 'Email',
						'rules' => 'trim|required|htmlspecialchars|valid_email'
					],

    		        [
						'field' => 'company_phone',
						'label' => 'Phone',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'company_website',
						'label' => 'Website',
						'rules' => 'trim|required|htmlspecialchars'
					],

					[
						'field' => 'company_address',
						'label' => 'Address',
						'rules' => 'trim|required|htmlspecialchars'
					],


					[
						'field' => 'company_pan',
						'label' => 'PAN',
						'rules' => 'trim|required|htmlspecialchars'
					],


					[
						'field' => 'company_gst',
						'label' => 'GST',
						'rules' => 'trim|required|htmlspecialchars'
					],

					[
						'field' => 'company_cin',
						'label' => 'CIN',
						'rules' => 'trim|required|htmlspecialchars'
					]

    		     ];

        return $rules; 

    }
    



    public function update_mail_settings(){

    	$rules = [

    		        [
						'field' => 'mail_from_name',
						'label' => 'From Name',
						'rules' => 'trim|required|htmlspecialchars'
					],

    		        [
						'field' => 'mail_from_email',
						'label' => 'From Email',
						'rules' => 'trim|required|htmlspecialchars|valid_email'
					],

    		        [
						'field' => 'mail_password',
						'label' => 'Password',
						'rules' => 'required'
					],

					[
						'field' => 'mail_host',
						'label' => 'Host',
						'rules' => 'trim|required|htmlspecialchars'
					],

					[
						'field' => 'mail_port',
						'label' => 'Port',
						'rules' => 'trim|required|htmlspecialchars|check_numeric'
					],

					[
						'field' => 'mailer_type',
						'label' => 'Mailer',
						'rules' => 'trim|required|htmlspecialchars|in_list[mail,sendmail,smtp]',
						'errors' => array('in_list' => 'Invalid value given in {field}')
					],

					[
						'field' => 'mailer_enc_type',
						'label' => 'Encryption',
						'rules' => 'trim|required|htmlspecialchars|in_list[ssl,tls]',
						'errors' => array('in_list' => 'Invalid value given in {field}')
					],

					[
						'field' => 'mail_reply_to',
						'label' => 'Reply-to Email',
						'rules' => 'trim|required|htmlspecialchars|valid_email'
					],

					[
						'field' => 'mail_content_type',
						'label' => 'Mail Type',
						'rules' => 'trim|required|htmlspecialchars|in_list[text,html]',
						'errors' => array('in_list' => 'Invalid value given in {field}')
					],

					[
						'field' => 'mail_testing',
						'label' => 'Testing Email',
						'rules' => 'trim|required|htmlspecialchars|valid_email'
					]

    		     ];

        return $rules; 
    }



    public function update_leave_settings(){

    	$rules =[
					[
						'field' => 'casual_leave_start_date',
						'label' => 'Casual Leave Gap Days',
						'rules' => 'required|trim|htmlspecialchars|less_than_equal_to[10]|greater_than_equal_to[-10]'
					],

					[
						'field' => 'planned_leave_start_date',
						'label' => 'Planned Leave Gap Days',
						'rules' => 'required|trim|htmlspecialchars|less_than_equal_to[10]|greater_than_equal_to[-10]'
					],

					[
						'field' => 'casual_leave_per_month',
						'label' => 'Casual Leave / Month',
						'rules' => 'required|trim|htmlspecialchars|less_than_equal_to[4]|greater_than_equal_to[-1]'
					]
    	        ];

    	return $rules;
    }



    public function add_announcement(){

    	$rules =[
					[
						'field' => 'announcement_title',
						'label' => 'Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'announcement_desc',
						'label' => 'Description',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'announcement_members',
						'label' => 'Shared With',
						'rules' => 'required|trim|htmlspecialchars|in_list[all,team_members,clients]'
					],

					[
						'field' => 'announcement_announce_date',
						'label' => 'Date',
						'rules' => 'required|trim|htmlspecialchars|check_date|check_previous_date'
					]
    	        ];

    	return $rules;
    }	


    public function add_member(){
    	$rules =[
					[
						'field' => 'project_members[]',
						'label' => 'Member',
						'rules' => 'required|trim|htmlspecialchars'
					]
    	        ];

    	return $rules;
    }



    public function add_team_member(){

    	$rules =[
					[
						'field' => 'user_first_name',
						'label' => 'First Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_last_name',
						'label' => 'Last Name',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_email',
						'label' => 'Email',
						'rules' => 'required|trim|htmlspecialchars|valid_email|is_unique[users.user_email]'
					],

					[
						'field' => 'user_mobile',
						'label' => 'Mobile',
						'rules' => 'required|trim|htmlspecialchars|check_numeric|exact_length[10]|is_unique[users.user_mobile]'
					],

					[
						'field' => 'user_alternate_phone',
						'label' => 'Alternate Mobile',
						'rules' => 'trim|htmlspecialchars|check_numeric|exact_length[10]|differs[user_mobile]'
					],

					[
						'field' => 'user_gender',
						'label' => 'Gender',
						'rules' => 'required|trim|htmlspecialchars|in_list[male,female,other]'
					],

					[
						'field' => 'user_dob',
						'label' => 'DOB',
						'rules' => 'required|trim|htmlspecialchars|check_date|check_future_date|validate_age_from_dob[15]'
					],

					[
						'field' => 'user_address',
						'label' => 'Address',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_alternate_address',
						'label' => 'Current Address',
						'rules' => 'trim|htmlspecialchars|differs[user_address]'
					],

					[
						'field' => 'user_job_title',
						'label' => 'JOB Title',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_hourly_cost',
						'label' => 'Hourly Cost',
						'rules' => 'trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'user_yearly_leave',
						'label' => 'Yearly Leave',
						'rules' => 'required|trim|htmlspecialchars|greater_than_equal_to[0]'
					],

					[
						'field' => 'user_skills[]',
						'label' => 'Skills',
						'rules' => 'required|trim|htmlspecialchars'
					],

					[
						'field' => 'user_date_of_joining',
						'label' => 'Date of Joining',
						'rules' => 'required|trim|htmlspecialchars|check_date'
					],

					[
						'field' => 'user_role_id',
						'label' => 'User Role',
						'rules' => 'required|trim|htmlspecialchars|check_val_exist[user_roles._urole_id]'
					],

					[
						'field' => 'user_emp_code',
						'label' => 'Employee Code',
						'rules' => 'required|trim|htmlspecialchars|is_unique[users.user_emp_code]'
					],

					[
						'field' => 'user_pan',
						'label' => 'PAN',
						'rules' => 'trim|htmlspecialchars|is_unique[users.user_pan]'
					]
    	        ];

    	return $rules;

    }	




}    