<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Announcement Model
*/
class Announcement_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}


	public function add_announcement(array $data){
		return $this->db->insert('announcement', $data) ? $this->db->insert_id() : FALSE; 
	}



	public function announcement_list($param=array()){

		if (isset($param['count'])) {

			$select = "COUNT(_announcement_id) AS count";
		}
		else{
			$select = "_announcement_id,announcement_title,announcement_desc,announcement_members,announcement_announce_date,
			            announcement_create_time,announcement_is_published,
			           _user_id,user_first_name,user_last_name,user_email,user_mobile,user_gender,user_image";
		}


		$this->db->select($select);

		$this->db->from('announcement');

		$this->db->join('users', 'announcement.announcement_created_by=users._user_id', 'INNER');

		$this->db->where('announcement_is_delete', 0);

		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_announcement_id']) && $param['_announcement_id']) {

        	$this->db->where('_announcement_id', $param['_announcement_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_announcement_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}

        	return $this->db->get()->result();
        }

	}	



	public function update_announcement($_announcement_id, array $data){
		return $this->db->where('_announcement_id', $_announcement_id)->update('announcement', $data);
	}


	public function get_todays_unpublished_announcement(){

		$this->db->from('announcement');

		$this->db->where('announcement_announce_date=CURDATE()', NULL, FALSE);

		$this->db->where('announcement_is_published', 0);

		return $this->db->get()->row();
	}



}