<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Attendence Model
*/
class Attendence_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}



	public function add_attendence(array $data){
		return $this->db->insert('attendence', $data) ? $this->db->insert_id() : FALSE; 
	}


	public function attendence_list($_fin_year_id, array $param){

		if (isset($param['count'])) {

			$select = "COUNT(_attendence_id) AS count";
		}
		else{
			$select = "_attendence_id, _user_id, user_first_name, user_last_name, user_image, user_gender,
                      attendence_date, attendence_in_time, attendence_out_time, attendence_login_hours";
		}


		$this->db->select($select);

		$this->db->from('attendence');

		$this->db->join('users', 'attendence.attendence_user_id=users._user_id', 'INNER');

		$this->db->where('attendence_fin_year_id', $_fin_year_id);
		
		if (isset($param['_user_id']) && $param['_user_id']) {
			$this->db->where('_user_id', $param['_user_id']);
		}

		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_attendence_id']) && $param['_attendence_id']) {

        	$this->db->where('_attendence_id', $param['_attendence_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_attendence_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}

        	return $this->db->get()->result();
        }

	}	



	public function update_attendence($_attendence_id, array $data){
		return $this->db->where('_attendence_id', $_attendence_id)->update('attendence', $data);
	}



	public function delete_attendence($_attendence_id){
		return $this->db->delete('attendence', ['_attendence_id' => $_attendence_id]);
	}




	public function add_summary(array $data){
		return $this->db->insert('attendence_summary', $data) ? $this->db->insert_id() : FALSE; 
	}



	public function summary_list($_fin_year_id, array $param){

		if (isset($param['count'])) {

			$select = "COUNT(_attendence_summary_id) AS count";
		}
		else{
			$select = "_attendence_summary_id, _user_id, user_first_name, user_last_name, user_image, user_gender,
                      DATE_FORMAT(attendence_summary_month, '%b, %Y') AS attendence_summary_month, attendence_summary_days_in_month,
                      attendence_summary_days_present, attendence_summary_days_absent, attendence_summary_leave_taken, 
                      attendence_summary_late_count, attendence_summary_avg_login_hours, attendence_summary_is_salary_slip_created, 
                      attendence_summary_salary_slip_id, attendence_summary_month AS attendence_summary_month_val";
		}


		$this->db->select($select);

		$this->db->from('attendence_summary');

		$this->db->join('users', 'attendence_summary.attendence_summary_user_id=users._user_id', 'INNER');

		$this->db->where('attendence_summary_fin_year_id', $_fin_year_id);
		
		if (isset($param['_user_id']) && $param['_user_id']) {
			$this->db->where('_user_id', $param['_user_id']);
		}


		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_attendence_summary_id']) && $param['_attendence_summary_id']) {

        	$this->db->where('_attendence_summary_id', $param['_attendence_summary_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_attendence_summary_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}

        	return $this->db->get()->result();
        }
	}



	public function update_summary($_attendence_summary_id, array $data){
		return $this->db->where('_attendence_summary_id', $_attendence_summary_id)->update('attendence_summary', $data);
	}



	public function delete_summary($_attendence_summary_id){
		return $this->db->delete('attendence_summary', ['_attendence_summary_id' => $_attendence_summary_id]);
	}







}	