<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Leave Model
*/
class Leave_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}




	public function apply_leave(array $data){
		return $this->db->insert('leave_applications', $data) ? $this->db->insert_id() : FALSE; 
	}



	public function applications($_fin_year_id, $param=array()){

		if (isset($param['count'])) {

			$select = "COUNT(_leave_id) AS count";
		}
		else{
			$select = "_leave_id, leave_type,leave_reason,leave_duration,leave_half_day,leave_start_date,leave_end_date,leave_no_of_days,
			           leave_status,leave_applied_by,leave_applied_time,leave_updated_by,leave_updated_time,
			           users._user_id,users.user_first_name,users.user_last_name,users.user_image,users.user_gender,
			           upd_user._user_id AS upd_user_id, upd_user.user_first_name AS upd_user_first_name, 
			           upd_user.user_last_name AS upd_user_last_name, upd_user.user_image AS upd_user_image,
			           upd_user.user_gender AS upd_user_gender";
		}


		$this->db->select($select);

		$this->db->from('leave_applications');

		$this->db->join('users', 'leave_applications.leave_user_id=users._user_id', 'INNER');

		$this->db->join('users upd_user', 'leave_applications.leave_updated_by=upd_user._user_id', 'LEFT');

		$this->db->where('leave_fin_year_id', $_fin_year_id);

		if (isset($param['_user_id']) && $param['_user_id']) {
			$this->db->where('users._user_id', $param['_user_id']);
		}	

		if (isset($param['like'])) {
			$this->db->group_start();

			$this->db->like('user_first_name', $param['like']);

			$this->db->or_like('user_last_name', $param['like']);

			$this->db->group_end();
		}


		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_leave_id']) && $param['_leave_id']) {

        	$this->db->where('_leave_id', $param['_leave_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_leave_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}

        	return $this->db->get()->result();
        }

	}



	public function update_application($_leave_id, array $data){
		return $this->db->where('_leave_id', $_leave_id)->update('leave_applications', $data);
	}



	public function user_month_wise_cl_approved_count($_fin_year_id, $_user_id, $month){

		$this->db->select("SUM(leave_no_of_days) AS `count`");

		$this->db->from("leave_applications");

		$this->db->where("leave_fin_year_id", $_fin_year_id);

		$this->db->where("leave_user_id", $_user_id);

		$this->db->where("leave_type", "casual");

		$this->db->where("leave_status", "approved");

		$this->db->where("DATE_FORMAT(leave_start_date, '%m')=".$month, NULL, FALSE);

		return $this->db->get()->row()->count;
	}






}	