<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Note Model
*/
class Note_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}



	public function add_note(array $data){
		return $this->db->insert('user_notes', $data) ? $this->db->insert_id() : FALSE; 
	}


	public function note_list($param=array()){

		if (isset($param['count'])) {

			$select = "COUNT(_unote_id) AS count";
		}
		else{
			$select = "_unote_id,unote_title,unote_desc,unote_create_time";
		}


		$this->db->select($select);

		$this->db->from('user_notes');


		if (isset($param['like'])) {
			$this->db->group_start();

			$this->db->like('unote_title', $param['like']);

			$this->db->group_end();
		}


		if (isset($param['_user_id'])) {
			$this->db->where('unote_user_id', $param['_user_id']);
		}	

		$this->db->where('unote_is_delete', 0);

		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_unote_id']) && $param['_unote_id']) {

        	$this->db->where('_unote_id', $param['_unote_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_unote_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}

        	return $this->db->get()->result();
        }
	}


	public function update_note($_unote_id, array $data){
		return $this->db->where('_unote_id', $_unote_id)->update('user_notes', $data);
	}


}	