<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Notification Model
*/
class Notification_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}



	public function add_notification(array $data){
		return $this->db->insert('notifications', $data) ? $this->db->insert_id() : FALSE; 
	}

	public function add_bulk_notifications(array $notifications){
		$this->db->insert_batch('notifications', $notifications);
	}	
	



	public function notifications($_user_id, $param=array()){

		if (isset($param['count'])) {

			$select = "COUNT(_notification_id) AS count";
		}
		else{
			$select = "_notification_id,notification_title,notification_action_type,notification_modal_id,notification_modal_data,
			          notification_modal_link,notification_modal_link_target,notification_is_read,notification_read_time,
			          notification_create_time,
			          _user_id,user_first_name,user_last_name,user_image,user_gender";
		}


		$this->db->select($select);

		$this->db->from('notifications');

		$this->db->join('users', 'notifications.notification_from_user_id=users._user_id', 'INNER');

		$this->db->where('notification_to_user_id', $_user_id);

		if (isset($param['notification_is_read'])) {
			$this->db->where('notification_is_read', $param['notification_is_read']);
		}


		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_notification_id']) && $param['_notification_id']) {

        	$this->db->where('_notification_id', $param['_notification_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_notification_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}
			elseif (isset($param['limit'])) {
				$this->db->limit($param['limit']);
			}

        	return $this->db->get()->result();
        }

	}	



	public function update_notification($_notification_id, array $data){
		return $this->db->where('_notification_id', $_notification_id)->update('notifications', $data);
	}



}	