<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Salary Model
*/
class Salary_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}


	public function add_salary(array $data){
		return $this->db->insert('salary_slips', $data) ? $this->db->insert_id() : FALSE; 
	}



	public function salary_list($_fin_year_id, $param=array()){

		if (isset($param['count'])) {

			$select = "COUNT(_salary_slip_id) AS count";
		}
		else{
			$select = "_salary_slip_id, salary_slip_month, salary_slip_per_month, salary_slip_basic, salary_slip_hra,
					  salary_slip_conveyance_allowance, salary_slip_special_allowance, salary_slip_work_from_home,
					  salary_slip_esic_employee, salary_slip_pf_employee, salary_slip_esic_employer, salary_slip_pf_employer,
					  salary_slip_professional_tax, salary_slip_tds, salary_slip_is_generated, salary_slip_create_time,
					  _user_id, user_first_name, user_last_name, user_gender, user_image";
		}


		$this->db->select($select);

		$this->db->from('salary_slips');

		$this->db->join('users', 'salary_slips.salary_slip_user_id=users._user_id', 'INNER');

		$this->db->where('salary_slip_fin_year_id', $_fin_year_id);

		if (isset($param['_user_id']) && $param['_user_id']) {

			$this->db->where('_user_id', $param['_user_id']);
		}



		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}
        elseif (isset($param['_salary_slip_id']) && $param['_salary_slip_id']) {

        	$this->db->where('_salary_slip_id', $param['_salary_slip_id']);

            return $this->db->get()->row();
        }
        else{

        	$this->db->order_by('_salary_slip_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {
				if ($param['limit']!='-1') {
					$this->db->limit($param['limit'], $param['offset']);
				}	
			}

        	return $this->db->get()->result();
        }
	}	



	public function update_salary($_salary_slip_id, array $data){
		return $this->db->where('_salary_slip_id', $_salary_slip_id)->update('salary_slips', $data);
	}



}	