<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
*  Settings Model
*/
class Settings_model extends MY_Model{

	public function __construct(){
		parent::__construct();
	}


	public function settings_by_key($settings_key){
		$data = $this->db->get_where('settings', ['settings_key' => $settings_key])->row();

		return $data ? $data->settings_value : NULL;
	}


	public function get_bulk_settings(array $settings_keys){

		$this->db->select('settings_key, settings_value');

		$this->db->from('settings');

		$this->db->where_in('settings_key', $settings_keys);

		return $this->db->get()->result();
	}



	public function update_settings($settings_key, $settings_value){
		return $this->db->where('settings_key', $settings_key)->update('settings', ['settings_value' => $settings_value]);
	}


	public function update_settings_batch(array $data){
		return $this->db->update_batch('settings', $data, 'settings_key');
	}


	public function current_fin_year(){

		return $this->db->from('financial_year')
		                ->where('fin_year_is_current', 1)
		                ->get()
		                ->row();
	}


	public function fin_years(){
		return $this->db->get('financial_year')->result();
	}


	public function fin_year_details($_fin_year_id){
		
		return $this->db->from('financial_year')
		                ->where('_fin_year_id', $_fin_year_id)
		                ->get()
		                ->row();
	}


	public function skills(){

		return $this->db->from('skills')
		                ->order_by('skill_name', 'ASC')
		                ->get()
		                ->result();
	}


	public function currencies(){
		return $this->db->from('currencies')
		                ->order_by('currency_name', 'ASC')
		                ->get()
		                ->result();
	}

}