<?php

defined('BASEPATH') OR exit('No direct script access allowed');

/**

*  User Model

*/

class User_model extends MY_Model{



	public function __construct(){

		parent::__construct();

	}



	public function login($user_email, $user_password, $token_device_type='web'){



		$user_data = $this->db->select('_user_id,user_first_name,user_last_name,user_image,user_gender,user_job_title,user_password,

			                           user_role_id')

		                      ->from('users')

		                      ->where('user_email', $user_email)

		                      ->where('user_is_active', 1)

		                      ->where('user_is_delete', 0)

		                      ->get()

		                      ->row();



		if ($user_data) {

		

			$this->load->library('password_hash');



         	$pass_check = FALSE;	



			try{

	            $pass_check = $this->password_hash->check_pass($user_data->user_password, $user_password);

	        }

	        catch(Exception $e) { 

	            //echo $e;

	        }



	        if ($pass_check) {



	        	$this->load->helper('encrypt_helper');



	        	$token_value_array =[

	                				   '_user_id' => $user_data->_user_id,

	                				   'time'     => time()

	                                ];



	            $token_value = aes128Encrypt(json_encode($token_value_array));



	            $this->load->library('user_agent');

	            

	            $user_token_data = 

	        	[

					'token_user_id'      => $user_data->_user_id,

					'token_value'        => $token_value,

					'token_cookie'       => $this->input->cookie($this->config->item('sess_cookie_name')),

					'token_device_type'  => $token_device_type,

					'token_ip_address'   => $this->input->ip_address(),

					'token_is_mobile'    => $this->agent->is_mobile(),

					'token_mobile_name'  => $this->agent->mobile(),

					'token_is_browser'   => $this->agent->is_browser(),

					'token_browser_name' => $this->agent->browser(),

					'token_browser_ver'  => $this->agent->version(), 

					'token_os'           => $this->agent->platform(),

					'token_user_agent'   => $this->input->user_agent()

		        ];



		        $_token_id = $this->db->insert('user_token', $user_token_data) ? $this->db->insert_id() : FALSE; 



		        if ($_token_id) {



		        	$upd_token_data=[

                						'token_is_valid'     => 0,

                						'token_invalid_time' => date('Y-m-d H:i:s'),

                						'token_destroy_type' => 're_login'

                	                ];



                    $this->db->group_start();



                		$this->db->where('token_value', $token_value);



						$this->db->where('_token_id!='.$_token_id, NULL, FALSE);



                	$this->db->group_end();





                	$this->db->or_group_start();



                	    $this->db->where('token_user_id', $user_token_data['token_user_id']);  



			    		$this->db->where('_token_id!='.$_token_id, NULL, FALSE);



                	$this->db->group_end();



                	$this->db->update('user_token', $upd_token_data);



                	unset($user_data->user_password);



                	$user_data->_token_id   = $_token_id;

                	$user_data->token_value = $token_value;



                	return $user_data;



		        }                   

	        }	

		}



		return FALSE;                       

	}



	public function logout($token_value){



		$upd_token_data = 	[

    							'token_is_valid'     => 0,

    							'token_invalid_time' => date('Y-m-d H:i:s'),

    							'token_destroy_type' => 'manual'

    	                  	];



    	if ($this->db->where('token_value', $token_value)->update('user_token', $upd_token_data)) {

    	    $this->session->sess_destroy();

    	    return TRUE;

    	}



    	return FALSE;              

	}



	public function verify_user_token($token_value, $log_url='', $log_param=''){



		$token_data = $this->db->from('user_token')

					           ->where('token_value', $token_value)

					           ->where('token_is_valid', 1)

					           ->get()

					           ->row();

		if ($token_data) {



			$this->db->where('_token_id', $token_data->_token_id)

		             ->update('user_token', [ 'token_last_access' => date('Y-m-d H:i:s')]);



			$log_data = [

						   'log_user_token_id' => $token_data->_token_id,

						   'log_url'           => $log_url ? $log_url : current_url(),

						   'log_param'         => json_encode($log_param ? $log_param : $this->input->post()) 

			            ];





			$_log_id = $this->db->insert('user_logs', $log_data) ? $this->db->insert_id() : FALSE;             

		}



		return $token_data;	  	         

		       

	}



	public function update_user($_user_id, array $data){



		if (isset($data['user_password'])) {

			$this->load->library('password_hash');

			$data['user_password'] = $this->password_hash->encrypt_pass($data['user_password']);

		}



		return $this->db->where('_user_id', $_user_id)->update('users', $data);

	}



	public function add_user(array $data){



		if (isset($data['user_password'])) {

			$this->load->library('password_hash');

			$data['user_password'] = $this->password_hash->encrypt_pass($data['user_password']);

		}



		return $this->db->insert('users', $data) ? $this->db->insert_id() : FALSE; 

	}



	public function user_list($param=array()){


		if (isset($param['count'])) {

			$select = "COUNT(_user_id) AS count";
		}
		else{
			$select = "*";
		}

		$this->db->select($select);

		$this->db->from('users');

		$this->db->join('user_token', 'users._user_id=user_token.token_user_id AND token_is_valid=1', 'LEFT');

		$this->db->join('user_roles', 'users.user_role_id=user_roles._urole_id', 'LEFT');

		if (isset($param['like'])) {

			$this->db->group_start();

			$this->db->like('user_first_name', $param['like']);

			$this->db->or_like('user_last_name', $param['like']);

			$this->db->or_like('user_job_title', $param['like']);

			$this->db->or_like('user_email', $param['like']);

			$this->db->or_like('user_mobile', $param['like']);

			$this->db->group_end();

		}

		if(isset($param['except_roles']) && $param['except_roles']){
			$this->db->where_not_in('user_role_id',$param['except_roles'],NULL,FALSE);
		}

		if (isset($param['user_role_id']) && $param['user_role_id']) {

			$this->db->where('user_role_id', $param['user_role_id']);
		}

		$this->db->where('user_is_delete', 0);

		if (isset($param['count'])) {
			return $this->db->get()->row()->count;
		}

        elseif (isset($param['_user_id']) && $param['_user_id']) {

        	$this->db->where('_user_id', $param['_user_id']);
            return $this->db->get()->row();
        }
        else{
        	$this->db->order_by('_user_id', 'DESC');

			if (isset($param['offset']) && isset($param['limit'])) {

				if ($param['limit']!='-1') {

					$this->db->limit($param['limit'], $param['offset']);

				}
			}

        	return $this->db->get()->result();

        }

	}



	public function bank_details($_user_id){



		return $this->db->select("bank_account_no,bank_name,bank_branch_name,bank_ifsc_code,_bank_id")

		                ->from("user_bank_details")

		                ->where("bank_user_id", $_user_id)

		                ->get()

		                ->row();

	}	





	public function update_bank_details($_user_id, array $data){



		$bank_data = $this->bank_details($_user_id);



		if ($bank_data) {

			return $this->db->where('_bank_id', $bank_data->_bank_id)->update('user_bank_details', $data);

		}

		else{

			$data['bank_user_id'] = $_user_id;

			return $this->db->insert('user_bank_details', $data) ? $this->db->insert_id() : FALSE; 

		}

		

	}



	public function salary_details($_user_id, $fin_year_id){



		$this->db->select("salary_total, salary_basic,salary_hra,salary_conveyance_allowance, salary_special_allowance, salary_work_from_home, salary_esic_employee, salary_pf_employee,salary_esic_employer, salary_pf_employer, salary_professional_tax, salary_tds,_salary_details_id");



		$this->db->from("user_salary_details");



		$this->db->where("salary_user_id", $_user_id);



		$this->db->where("salary_fin_year_id", $fin_year_id);



		return $this->db->get()->row();

	}





	public function update_salary_details($_user_id, $fin_year_id, array $data){



		$salary_data = $this->salary_details($_user_id, $fin_year_id);

		if ($salary_data) {

			return $this->db->where('_salary_details_id', $salary_data->_salary_details_id)->update('user_salary_details', $data);

		}

		else{

			$data['salary_fin_year_id'] = $fin_year_id;

			$data['salary_user_id'] = $_user_id;

			return $this->db->insert('user_salary_details', $data) ? $this->db->insert_id() : FALSE; 

		}

	}



}	