<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>

<div id="page-wrapper">
<div class="main-page">
<div class="tables">
  <h2 class="title1">Settings</h2>

  <ol class="breadcrumb">
    <li><a href="<?= site_url() ?>"><i class="fa fa-dashboard"></i>  Dashboard</a></li>
    <li ><i class="fa fa-cogs"></i> Settings</li>
    <li><a href="<?= site_url('settings/general') ?>"><i class="fa fa-square-o"></i> General Settings</a></li>
  </ol>
  
  <div class="panel panel-info"> 

    <div class="panel-heading"> 
      <div class="row">
        <div class="col-md-9">
          General Settings
        </div>
      </div>
    </div>

    <div class="panel-body">
      <form action="settings/update-general-settings" method="post" class="xhr_form" id="update-general-settings">

      <div class="row">

        <div class="col-lg-4">
          <label>Title Bar Text <span class="text-danger">*</span></label>
          <input type="text" name="title_bar_name" class="form-control" value="<?= $general_settings['title_bar_name'] ?>">

          <p id="title_bar_name_error"></p>
        </div>

        <div class="col-lg-2">
          <label>Favicon <span class="text-danger">*</span></label>

          <img src="<?= base_url($general_settings['favicon']) ?>" class="img-responsive" id="favicon_img"
              style="border: solid 1px #337ab7; padding: 5px; height: 50px; max-width: 100%; cursor: pointer;" 
              onclick="chooseFile('favicon');">

          <input type="file" name="favicon" accept=".jpg,.jpeg,.png" style="display: none;" id="favicon" 
                 onchange="upload_file(this, 'jpg|jpeg|png', 'favicon_img');">        

          <p id="favicon_error"></p>

        </div> 

        <div class="col-lg-3">
          <label>Logo Small<span class="text-danger">*</span></label>

          <img src="<?= base_url($general_settings['logo_icon']) ?>" class="img-responsive" id="logo_icon_img"
              style="border: solid 1px #337ab7; padding: 5px; height: 100px; max-width: 100%; cursor: pointer;" 
              onclick="chooseFile('logo_icon');">

          <input type="file" name="logo_icon" accept=".jpg,.jpeg,.png" style="display: none;" id="logo_icon" 
                 onchange="upload_file(this, 'jpg|jpeg|png', 'logo_icon_img');">        

          <p id="logo_icon_error"></p>

        </div> 


        <div class="col-lg-3">
          <label>Logo Wide<span class="text-danger">*</span></label>

          <img src="<?= base_url($general_settings['logo_wide']) ?>" class="img-responsive" id="logo_wide_img"
              style="border: solid 1px #337ab7; padding: 10px; height: 100px; max-width: 100%; cursor: pointer;" 
              onclick="chooseFile('logo_wide');">

          <input type="file" name="logo_wide" accept=".jpg,.jpeg,.png" style="display: none;" id="logo_wide" 
                 onchange="upload_file(this, 'jpg|jpeg|png', 'logo_wide_img');">        

          <p id="logo_wide_error"></p>

        </div> 


      </div>  


      <div class="row">

        <div class="col-lg-4">
          <label>Logo Transparent<span class="text-danger">*</span></label>

          <img src="<?= base_url($general_settings['logo_transparent']) ?>" class="img-responsive" id="logo_transparent_img"
              style="border: solid 1px #337ab7; padding: 10px; height: 100px; max-width: 100%; cursor: pointer; background-color: #222d32;" 
              onclick="chooseFile('logo_transparent');">

          <input type="file" name="logo_transparent" accept=".jpg,.jpeg,.png" style="display: none;" id="logo_transparent" 
                 onchange="upload_file(this, 'jpg|jpeg|png', 'logo_transparent_img');">        

          <p id="logo_transparent_error"></p>

        </div>


        <div class="col-lg-4">
          <label>Logo Transparent Wide<span class="text-danger">*</span></label>

          <img src="<?= base_url($general_settings['logo_wide_transparent']) ?>" class="img-responsive" id="logo_wide_transparent_img"
              style="border: solid 1px #337ab7; padding: 10px; height: 100px; max-width: 100%; cursor: pointer; background-color: #222d32;" 
              onclick="chooseFile('logo_wide_transparent');">

          <input type="file" name="logo_wide_transparent" accept=".jpg,.jpeg,.png" style="display: none;" id="logo_wide_transparent" 
                 onchange="upload_file(this, 'jpg|jpeg|png', 'logo_wide_transparent_img');">        

          <p id="logo_wide_transparent_error"></p>

        </div>


        <div class="col-lg-4">
          <label>Logo Transparent Big<span class="text-danger">*</span></label>

          <img src="<?= base_url($general_settings['logo_transparent_big']) ?>" class="img-responsive" id="logo_transparent_big_img"
              style="border: solid 1px #337ab7; padding: 10px; height: 100px; max-width: 100%; cursor: pointer; background-color: #222d32;" 
              onclick="chooseFile('logo_transparent_big');">

          <input type="file" name="logo_transparent_big" accept=".jpg,.jpeg,.png" style="display: none;" id="logo_transparent_big" 
                 onchange="upload_file(this, 'jpg|jpeg|png', 'logo_transparent_big_img');">        

          <p id="logo_transparent_big_error"></p>

        </div>


      </div> 


      <div class="row">

        <div class="col-lg-12">
          <label>Copyright <span class="text-danger">*</span></label>
          <textarea class="form-control" name="copyright_text" id="copyright_text"><?= $general_settings['copyright_text'] ?></textarea>

          <p id="copyright_text_error"></p>
        </div> 

      </div> 


      


      <div class="row">
        <div class="col-lg-offset-10 col-lg-2">
          <button type="submit" class="btn btn-block btn-primary" style="margin-top: 20px;"> Update</button>
        </div>
      </div> 
    </form>
    </div>
    
  </div>

</div>
</div>
</div>


<script type="text/javascript">
$(document).ready(function () {

  if ($("#copyright_text").length) {
    CKEDITOR.replace( 'copyright_text', {
      customConfig: base_url('assets/js/ckeditor-config.js')
    });
  }

}); 
</script> 