<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>

<div id="page-wrapper">
<div class="main-page">
<div class="tables">
  <h2 class="title1">Settings</h2>

  <ol class="breadcrumb">
    <li><a href="<?= site_url() ?>"><i class="fa fa-dashboard"></i>  Dashboard</a></li>
    <li ><i class="fa fa-cogs"></i> Settings</li>
    <li><a href="<?= site_url('settings/mail-settings') ?>"><i class="fa fa-square-o"></i> Mail Settings</a></li>
  </ol>
  
  <div class="panel panel-info"> 

    <div class="panel-heading"> 
      <div class="row">
        <div class="col-md-9">
          Mail Settings
        </div>
      </div>
    </div>

    <div class="panel-body">


      <div class="row">

        <div class="col-lg-4">
          <label>From Name <span class="text-danger">*</span></label>
          <input type="text" name="mail_from_name" class="form-control" value="<?= $mail_settings['mail_from_name'] ?>">

          <p id="mail_from_name_error"></p>
        </div>  

        <div class="col-lg-4">
          <label>From Email <span class="text-danger">*</span></label>
          <input type="text" name="mail_from_email"  class="form-control" value="<?= $mail_settings['mail_from_email'] ?>">

          <p id="mail_from_email_error"></p>
        </div>  

        <div class="col-lg-4">
          <label for="">Password <span class="text-danger">*</span></label>
          <div class="input-group">
            <input name="mail_password" id="password" type="password" class="form-control" 
                   value="<?= $mail_settings['mail_password'] ?>">

            <span class="input-group-addon" >
              <img src="<?= base_url('assets/images/upload/eye-open.png') ?>" id='pwdbtn' title='Show Password' 
                   onclick="show_password(this.id, $('#password'))" style='cursor: pointer;'>
            </span>
          </div>
          <p id="mail_password_error"></p>
        </div> 

      </div> 

      <div class="row">

        <div class="col-lg-4">
          <label>Host <span class="text-danger">*</span></label>
          <input type="text" name="mail_host" class="form-control" value="<?= $mail_settings['mail_host'] ?>">

          <p id="mail_host_error"></p>
        </div>  

        <div class="col-lg-4">
          <label>Port <span class="text-danger">*</span></label>
          <input type="text" name="mail_port" class="form-control numeric no_zero_start" maxlength="4" 
                 value="<?= $mail_settings['mail_port'] ?>">

          <p id="mail_port_error"></p>
        </div>  

        <div class="col-lg-4">
          <label>Mailer <span class="text-danger">*</span></label>

          <select class="form-control" name="mailer_type">
            <option value="" hidden>Select Mailer</option>
            <option value="mail" 
                <?= $mail_settings['mailer_type']=="mail" ? 'selected' : NULL ?> >mail
            </option>
            <option value="sendmail" 
                <?= $mail_settings['mailer_type']=="sendmail" ? 'selected' : NULL ?> >sendmail
            </option>
            <option value="smtp" 
                 <?= $mail_settings['mailer_type']=="smtp" ? 'selected' : NULL ?> >smtp
            </option>
          </select>

          <p id="mailer_type_error"></p>
        </div> 

      </div> 


      <div class="row">

        <div class="col-lg-4">
          <label>Encryption <span class="text-danger">*</span></label>
          <select class="form-control" name="mailer_enc_type">
            <option value="" hidden>Select Encryption</option>
            <option value="ssl" 
                <?= $mail_settings['mailer_enc_type']=="ssl" ? 'selected' : NULL ?> >ssl
            </option>
            <option value="tls" 
                <?= $mail_settings['mailer_enc_type']=="tls" ? 'selected' : NULL ?> >tls
            </option>
          </select>
          <p id="mailer_enc_type_error"></p>
        </div>  

        <div class="col-lg-4">
          <label>Reply-to Email <span class="text-danger">*</span></label>
          <input type="text" name="mail_reply_to" class="form-control" value="<?= $mail_settings['mail_reply_to'] ?>">
          <p id="mail_reply_to_error"></p>
        </div>  

        <div class="col-lg-4">
          <label>Mail Type <span class="text-danger">*</span></label>
          <select class="form-control" name="mail_content_type">
            <option value="" hidden>Select Mail Type</option>
            <option value="text" 
              <?= $mail_settings['mail_content_type']=="text" ? 'selected' : NULL ?> >text
            </option>
            <option value="html" 
              <?= $mail_settings['mail_content_type']=="html" ? 'selected' : NULL ?> >html
            </option>
          </select>
          <p id="mail_content_type_error"></p>
        </div> 

      </div>


      <div class="row">

        <div class="col-lg-4">
          <label>Testing Email <span class="text-danger">*</span></label>
          <input type="text" name="mail_testing" class="form-control" placeholder="Email to settings">

          <p id="mail_testing_error"></p>
        </div>

      </div>  

      <div class="row">
        <div class="col-lg-offset-10 col-lg-2">
          <button type="submit" class="btn btn-block btn-primary" style="margin-top: 20px;"> Update</button>
        </div>
      </div> 

    </div>
    
  </div>

</div>
</div>
</div>