<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>
<div class="panel panel-info"> 	 
	<div class="panel-heading">Projects</div>
	<div class="panel-body">
		<table class="table table-striped table-bordered table-advance table-hover" id="project-list">
			<thead>
				<tr>
					<th class="tbl_label" >	#</th>
					<th class="tbl_label" > Title</th>
					<th class="tbl_label" >	Price</th>
					<th class="tbl_label" >	Start Date</th>
					<th class="tbl_label" >	Deadline</th>
					<th class="tbl_label" >	Status</th>
					<th class="tbl_label" >	<i class="fa fa-cogs"></i></th>
				</tr>
			</thead>
		</table>

		<input type="hidden" id="_client_id" value="<?= $client_data->_client_id ?>">
	</div>
</div>
<script type="text/javascript">
$(document).ready(function () {
	clients_project_list();
});	

function clients_project_list(){

	var _client_id = $('#_client_id').val();

	if (ctrl=='clients' && method=='details') {

		var url = site_url('xhr/clients/project-list/'+_client_id); 

		dataTable = $('#project-list').DataTable({
        dom: 'lBfrtip',
        responsive: true,
        ordering : false,

        lengthMenu: [[10, 25, 100, -1], [10, 25, 100, "All"]],
        pageLength: 10,
        buttons:[
                  	{
                    	extend: 'print',
                    	text: '<button class="btn btn-primary btn-sm" ><i class="fa fa-print fa-x5"> Print</i></button>',
                    	autoPrint: false,
                    	exportOptions: {
                        	columns: [0,1,2,3,4,5,6]
                    	}
                  	},

                  	{
                    	extend: 'excelHtml5',
                    	text: '<button class="btn btn-success btn-sm"><i class="fa fa-file-excel-o fa-x5"> Excel</i></button>',
                    	exportOptions: {
                        	columns: [0,1,2,3,4,5,6]
                      	}
                  	},

                  	{
                      	extend: 'pdfHtml5',
                      	text: '<button class="btn btn-danger btn-sm"><i class="fa fa-file-pdf-o fa-x5"> PDF</i></button>',
                      	exportOptions: {
                        	columns: [0,1,2,3,4,5,6]
                      	}
                  	}
        		],

    	"processing": true,
    	"serverSide": true,
    	"ajax":{
	      	url : url, // json datasource
	      	type: "post",  // method  , by default get
	      	error: function(){  // error handling
		        $(".project-list-error").html("");
		        $("#project-list-grid").append('<tbody class="current-donors-list-error"><tr><th colspan="8">No data found</th></tr></tbody>');
		        $("#project-list_processing").css("display","none");
	      	}
    	},

	    "language": {
	                  processing: '<i class="fa fa-spinner fa-spin fa-3x fa-fw"></i><span class="sr-only">Loading..n.</span> '
	                }
  		});
	}
}
</script>