<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>
<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="edit-project-modal" 
class="modal fade">
  <div class="modal-dialog ">
    <div class="modal-content">
      <div class="modal-header">
        <button aria-hidden="true" data-dismiss="modal" class="close" type="button">×</button>
        <h4 class="modal-title">Update Project </h4>
      </div>
      <div class="modal-body">
        <form action="projects/edit-project" method="post" class="xhr_form form-horizontal" id="edit-project">
          <div class="form-group row">
            <div class="col-md-6">
              <label for="exampleInputEmail1">Project Title <span class="text-danger">*</span></label>
              <input type="text" name="project_title" class="form-control" value="<?= $project_data->project_title ?>">
              <p id="project_title_error"></p>
            </div>
            <div class="col-md-6">
              <label for="exampleInputEmail1">Client <span class="text-danger">*</span></label>
              <input type="text" class="form-control" readonly value="<?= $project_data->client_name ?>">
              <p id="project_client_id_error"></p>
            </div>
            <input type="hidden" name="_project_id" value="<?= $project_data->_project_id ?>">
          </div>

          <div class="form-group row">
            <div class="col-md-12">
              <label>Description</label>
              <textarea class="form-control" name="project_description" rows="5"><?= $project_data->project_description ?></textarea>
            </div>
          </div>

          <div class="form-group row">
            <div class="col-md-6 col-sm-12">  
              <label for="exampleInputEmail1">Start Date <span class="text-danger">*</span></label>
              <div class="input-group">
                <input type="text" name="project_start_date" id="project-start-date" class="form-control" placeholder="DD-MM-YYYY" value="<?= web_date_format($project_data->project_start_date) ?>">
                <label class="input-group-addon" style="cursor: pointer;" for="project-start-date">
                  <i class="fa fa-calendar"></i>
                </label>   
              </div>
              <p id="project_start_date_error"></p>
            </div>

            <div class="col-md-6 col-sm-12">  
              <label for="exampleInputEmail1">Deadline <span class="text-danger">*</span></label>
              <div class="input-group">
                <input type="text" name="project_deadline" id="project-end-date" class="form-control" placeholder="DD-MM-YYYY" value="<?= web_date_format($project_data->project_deadline) ?>">
                <label class="input-group-addon" style="cursor: pointer;" for="project-end-date">
                  <i class="fa fa-calendar"></i>
                </label>   
              </div>
              <p id="project_deadline_error"></p>
            </div>
          </div>
          
          <div class="form-group row">
            <div class="col-md-6">
              <label for="exampleInputEmail1">Price <span class="text-danger">*</span></label>
              <input type="text" name="project_price" class="form-control decimal" value="<?= $project_data->project_price ?>">
              <p id="project_price_error"></p>
            </div>
            <div class="col-md-6">
              <label for="exampleInputEmail1">Skills <span class="text-danger">*</span></label>
              <select class="selectpicker form-control" name="project_skills[]" id="project_skills" multiple="" data-live-search="true" data-none-selected-text="Select Skills">
                <option value="" hidden>Select Skills</option>
<?php
  if($skills){
    $project_skills = explode(',', $project_data->project_skills);
    foreach($skills as $skill){
      $selected = in_array($skill->_skill_id, $project_skills)?'selected':'';
?>
                <option value="<?= $skill->_skill_id ?>" <?= $selected ?>><?= $skill->skill_name ?></option>
<?php
    }
  }
?>
              </select>
              <p id="project_skills_error"></p>
            </div>
            
          </div>

          <div class="form-group row">
            <div class="col-md-6">
              <label>Status</label>
              <select name="project_status" class="form-control">
                <option value="0" <?= $project_data->project_status==0?'selected':'' ?> >Open</option>
                <option value="1" <?= $project_data->project_status==1?'selected':'' ?> >Completed</option>
                <option value="2" <?= $project_data->project_status==2?'selected':'' ?> >Cancelled</option>
              </select>
            </div>
          </div>

          <div class="form-group row">
            <div class="col-md-4">
              <button type="submit" class="btn btn-primary btn-block">Submit</button>
            </div>
          </div>

        </form>
      </div>
    </div>
  </div>
</div>
<script type="text/javascript">
$(document).ready(function () {
  date_picker_options();
}); 
</script>