<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>
<!DOCTYPE html>
<html>
<head>
	<title><?= $settings['title_bar_name'] ?></title>

	<link rel="icon" href="<?= base_url($settings['favicon']) ?>" type="image/x-icon" />

	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

	<!-- Optional theme -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">

	<!-- Latest compiled and minified JavaScript -->
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>

</head>
<body>

<div class="container">
	<h1>Terms & Conditions</h1>
	<h2>1. Acceptance of the Terms of Use</h2>
	<p>
		The following terms and conditions, together with any referenced
	    documents (collectively, &quot;<b>Terms of Use</b>&quot;) form a legal
	    agreement between you and your employer, employees, agents,
	    contractors and any other entity on whose behalf you accept these
	    terms (collectively, “<b>you</b>” and “<b>your</b>”), and ServiceNow,
	    Inc. (“<b>ServiceNow</b>,” “<b>we</b>,” “<b>us</b>” and “<b>our</b>”).
	    The Terms of Use apply to the demonstration services available on the
	    website where these Terms of Use are presented, including any
	    ServiceNow Intellectual Property (as defined below) therein (the
	    “<strong><?= $settings['company_name'] ?></strong>”).
	</p>

    <p>
    	By accessing or using the Demo Website, or by clicking to accept or
	    agree to the Terms of Use when this option is made available to you,
	    you represent that you have read and understood, and agree to be bound
	    by these Terms of Use. If you do not agree to these Terms of Use, you
	    may not use the <strong><?= $settings['company_name'] ?></strong>.
	</p>

 	<p>
 		Personally identifiable information collected about you by this <strong><?= $settings['company_name'] ?></strong> 
 		is treated in accordance with the 
 		<a href="<?= site_url('privacy-policy') ?>" target="_blank">Privacy Policy</a>, which is hereby incorporated into these Terms of Use by
        reference. If you do not agree to these Terms of Use or the 
        <a href="<?= site_url('privacy-policy') ?>" target="_blank">Privacy Policy</a>, you must accept these Terms of Use or access the 
        <strong><?= $settings['company_name'] ?></strong>.
	</p>

	<p>
		<strong>Access</strong>
	</p>

	<p>
		We reserve the right to terminate or modify the Demo Website in
	    whole or in part, in any manner in our sole discretion, without
	    notice. We will not be liable if, for any reason, all or any part of
	    the Demo Website is unavailable at any time or for any period. From
	    time to time, we may restrict access to all or part of the <strong><?= $settings['company_name'] ?></strong> 
	    to a subset of permitted users. You are solely responsible for
	    making all arrangements necessary for you to access the <strong><?= $settings['company_name'] ?></strong>.
	</p>

	<p>
		You shall use the Demo Website exclusively to test and evaluate the
	    ServiceNow product and service, and you shall access it only through
	    the registration portal, regardless of any previous registration or
	    access. To access portions of the Demo Website or certain resources,
	    you may be asked to provide certain registration details or other
	    information.  It is a condition of your use of the Demo Website, and
	    you hereby represent and warrant, that all information you provide is
	    correct, current and complete. You must logout from the <strong><?= $settings['company_name'] ?></strong>
	    at the end of each session. You agree that you are solely responsible
	    to us for all activities identified with your access and registration.
	    ServiceNow has the absolute right to disable any user name or
	    password, at any time, for any reason, including, if in our sole
	    discretion we believe that you have failed to comply with any
	    provision of these Terms of Use.
	</p>

	<p>
		<strong>Data Visible to Other Users</strong>
	</p>

	<p>
		The Demo Website is a collection of shared instances that
        automatically reset on a timed schedule. Anything input by a user of
	    the Demo Website that remains on an instance following your use will
	    be visible and usable to all other users that access the same instance
	    before it is reset.  In addition to the rights provided to ServiceNow
	    above, you hereby grant to all users of the Demo Website a
	    royalty‑free, fully‑paid, non‑exclusive, non‑transferable,
	    sub‑licensable, worldwide right to use any data and intellectual
	    property provided by you to each other user of the Demo Website solely
	    to use the Demo Website as described herein.
	</p>

	<h2>2. Prohibited Uses</h2>

	<p>
		You agree not to access or use (and shall not permit others to access
        or use) the Demo Website or ServiceNow Intellectual Property in any manner:
	</p>

	<ul>
		<li>
			Other than for product evaluation purposes (specifically
            excluding product demonstration, development, or any production or
            commercial purposes).
		</li>

		<li>
			To process, use, transmit or
		    introduce any confidential or sensitive information of any kind,
		    including personally identifiable information, sensitive personal
		    data, health information of any kind, or factual data regarding your
		    employees or third data, and particularly excluding: (1) information
		    protected under the privacy or security regulations issued pursuant
		    to the Health Insurance Portability and Accountability Act of 1996
		    (HIPAA) or subject to the Health Information Technology for Economic
		    and Clinical Health (HITECH) Act; or (2) non‑public sensitive or
		    personally identifiable information including but not limited to
		    drivers license numbers, passport numbers, social security numbers,
		    tax identification numbers, voter registration numbers or similar
		    identifying numbers, health information, or financial information
		    including bank, checking, credit card, debit card, or other account numbers.
		</li>

		<li>
			To license, sub‑license, sell, re‑sell, rent, lease,
            transfer, distribute or time share or otherwise make them available
            for access by third parties.
		</li>

		<li>
			To disassemble, reverse
            engineer, decompile or modify them or otherwise create derivative
            works of them.
		</li>

		<li>
			To access them for the purpose of developing
            a product or service that competes with a ServiceNow Product.
		</li>

		<li>
			To use them to create, use, send, store or run viruses or other
            harmful computer code, files, scripts, agents or other programs or
            engage in any other malicious act.
		</li>

		<li>
			To disrupt their security, integrity or operation.
		</li>

		<li>
			To remove or modify a copyright or other proprietary rights notice in them.
		</li>

		<li>
			To use them to reproduce, distribute, display, transmit or use material
            protected by copyright or other intellectual property right
            (including the rights of publicity or privacy) without first
            obtaining the permission of the owner.
		</li>
	</ul>

</div>


</body>
</html>